/*
**  MMXmark benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005-07 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl mmxwr
mmxwr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
	pxor	%mm0, %mm0
.mainwr:
	movq	%mm0, 0(%rsi)
	movq	%mm0, 8(%rsi)
	movq	%mm0, 16(%rsi)
	movq	%mm0, 24(%rsi)
	movq	%mm0, 32(%rsi)
	movq	%mm0, 40(%rsi)
	movq	%mm0, 48(%rsi)
	movq	%mm0, 56(%rsi)
	movq	%mm0, 64(%rsi)
	movq	%mm0, 72(%rsi)
	movq	%mm0, 80(%rsi)
	movq	%mm0, 88(%rsi)
	movq	%mm0, 96(%rsi)
	movq	%mm0, 104(%rsi)
	movq	%mm0, 112(%rsi)
	movq	%mm0, 120(%rsi)
	movq	%mm0, 128(%rsi)
	movq	%mm0, 136(%rsi)
	movq	%mm0, 144(%rsi)
	movq	%mm0, 152(%rsi)
	movq	%mm0, 160(%rsi)
	movq	%mm0, 168(%rsi)
	movq	%mm0, 176(%rsi)
	movq	%mm0, 184(%rsi)
	movq	%mm0, 192(%rsi)
	movq	%mm0, 200(%rsi)
	movq	%mm0, 208(%rsi)
	movq	%mm0, 216(%rsi)
	movq	%mm0, 224(%rsi)
	movq	%mm0, 232(%rsi)
	movq	%mm0, 240(%rsi)
	movq	%mm0, 248(%rsi)
	movq	%mm0, 256(%rsi)
	movq	%mm0, 264(%rsi)
	movq	%mm0, 272(%rsi)
	movq	%mm0, 280(%rsi)
	movq	%mm0, 288(%rsi)
	movq	%mm0, 296(%rsi)
	movq	%mm0, 304(%rsi)
	movq	%mm0, 312(%rsi)
	movq	%mm0, 320(%rsi)
	movq	%mm0, 328(%rsi)
	movq	%mm0, 336(%rsi)
	movq	%mm0, 344(%rsi)
	movq	%mm0, 352(%rsi)
	movq	%mm0, 360(%rsi)
	movq	%mm0, 368(%rsi)
	movq	%mm0, 376(%rsi)
	movq	%mm0, 384(%rsi)
	movq	%mm0, 392(%rsi)
	movq	%mm0, 400(%rsi)
	movq	%mm0, 408(%rsi)
	movq	%mm0, 416(%rsi)
	movq	%mm0, 424(%rsi)
	movq	%mm0, 432(%rsi)
	movq	%mm0, 440(%rsi)
	movq	%mm0, 448(%rsi)
	movq	%mm0, 456(%rsi)
	movq	%mm0, 464(%rsi)
	movq	%mm0, 472(%rsi)
	movq	%mm0, 480(%rsi)
	movq	%mm0, 488(%rsi)
	movq	%mm0, 496(%rsi)
	movq	%mm0, 504(%rsi)
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainwr

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxrd
mmxrd:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$5, %rcx
	pxor	%mm0, %mm0
.prerd:
	movq	%mm0, 0(%rax)
	movq	%mm0, 8(%rax)
	movq	%mm0, 16(%rax)
	movq	%mm0, 24(%rax)
	addq	$32, %rax
	loopq	.prerd
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
.mainrd:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	movq	288(%rsi), %mm4
	movq	296(%rsi), %mm5
	movq	304(%rsi), %mm6
	movq	312(%rsi), %mm7
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	movq	352(%rsi), %mm4
	movq	360(%rsi), %mm5
	movq	368(%rsi), %mm6
	movq	376(%rsi), %mm7
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	movq	416(%rsi), %mm4
	movq	424(%rsi), %mm5
	movq	432(%rsi), %mm6
	movq	440(%rsi), %mm7
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	movq	480(%rsi), %mm4
	movq	488(%rsi), %mm5
	movq	496(%rsi), %mm6
	movq	504(%rsi), %mm7
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainrd

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxwr_nt
mmxwr_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
	pxor	%mm0, %mm0
.mainwr_nt:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	movntq	%mm0, 32(%rsi)
	movntq	%mm0, 40(%rsi)
	movntq	%mm0, 48(%rsi)
	movntq	%mm0, 56(%rsi)
	movntq	%mm0, 64(%rsi)
	movntq	%mm0, 72(%rsi)
	movntq	%mm0, 80(%rsi)
	movntq	%mm0, 88(%rsi)
	movntq	%mm0, 96(%rsi)
	movntq	%mm0, 104(%rsi)
	movntq	%mm0, 112(%rsi)
	movntq	%mm0, 120(%rsi)
	movntq	%mm0, 128(%rsi)
	movntq	%mm0, 136(%rsi)
	movntq	%mm0, 144(%rsi)
	movntq	%mm0, 152(%rsi)
	movntq	%mm0, 160(%rsi)
	movntq	%mm0, 168(%rsi)
	movntq	%mm0, 176(%rsi)
	movntq	%mm0, 184(%rsi)
	movntq	%mm0, 192(%rsi)
	movntq	%mm0, 200(%rsi)
	movntq	%mm0, 208(%rsi)
	movntq	%mm0, 216(%rsi)
	movntq	%mm0, 224(%rsi)
	movntq	%mm0, 232(%rsi)
	movntq	%mm0, 240(%rsi)
	movntq	%mm0, 248(%rsi)
	movntq	%mm0, 256(%rsi)
	movntq	%mm0, 264(%rsi)
	movntq	%mm0, 272(%rsi)
	movntq	%mm0, 280(%rsi)
	movntq	%mm0, 288(%rsi)
	movntq	%mm0, 296(%rsi)
	movntq	%mm0, 304(%rsi)
	movntq	%mm0, 312(%rsi)
	movntq	%mm0, 320(%rsi)
	movntq	%mm0, 328(%rsi)
	movntq	%mm0, 336(%rsi)
	movntq	%mm0, 344(%rsi)
	movntq	%mm0, 352(%rsi)
	movntq	%mm0, 360(%rsi)
	movntq	%mm0, 368(%rsi)
	movntq	%mm0, 376(%rsi)
	movntq	%mm0, 384(%rsi)
	movntq	%mm0, 392(%rsi)
	movntq	%mm0, 400(%rsi)
	movntq	%mm0, 408(%rsi)
	movntq	%mm0, 416(%rsi)
	movntq	%mm0, 424(%rsi)
	movntq	%mm0, 432(%rsi)
	movntq	%mm0, 440(%rsi)
	movntq	%mm0, 448(%rsi)
	movntq	%mm0, 456(%rsi)
	movntq	%mm0, 464(%rsi)
	movntq	%mm0, 472(%rsi)
	movntq	%mm0, 480(%rsi)
	movntq	%mm0, 488(%rsi)
	movntq	%mm0, 496(%rsi)
	movntq	%mm0, 504(%rsi)
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainwr_nt

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxrd_nt
mmxrd_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$5, %rcx
	pxor	%mm0, %mm0
.prerd_nt:
	movntq	%mm0, 0(%rax)
	movntq	%mm0, 8(%rax)
	movntq	%mm0, 16(%rax)
	movntq	%mm0, 24(%rax)
	addq	$32, %rax
	loopq	.prerd_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	decq	%rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
.mainrd_nt:
/* every loop prefetches the next one */
	prefetchnta	512(%rsi)
	prefetchnta	576(%rsi)
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	prefetchnta	640(%rsi)
	prefetchnta	704(%rsi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	prefetchnta	768(%rsi)
	prefetchnta	832(%rsi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	prefetchnta	896(%rsi)
	prefetchnta	960(%rsi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	movq	288(%rsi), %mm4
	movq	296(%rsi), %mm5
	movq	304(%rsi), %mm6
	movq	312(%rsi), %mm7
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	movq	352(%rsi), %mm4
	movq	360(%rsi), %mm5
	movq	368(%rsi), %mm6
	movq	376(%rsi), %mm7
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	movq	416(%rsi), %mm4
	movq	424(%rsi), %mm5
	movq	432(%rsi), %mm6
	movq	440(%rsi), %mm7
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	movq	480(%rsi), %mm4
	movq	488(%rsi), %mm5
	movq	496(%rsi), %mm6
	movq	504(%rsi), %mm7
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainrd_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	movq	288(%rsi), %mm4
	movq	296(%rsi), %mm5
	movq	304(%rsi), %mm6
	movq	312(%rsi), %mm7
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	movq	352(%rsi), %mm4
	movq	360(%rsi), %mm5
	movq	368(%rsi), %mm6
	movq	376(%rsi), %mm7
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	movq	416(%rsi), %mm4
	movq	424(%rsi), %mm5
	movq	432(%rsi), %mm6
	movq	440(%rsi), %mm7
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	movq	480(%rsi), %mm4
	movq	488(%rsi), %mm5
	movq	496(%rsi), %mm6
	movq	504(%rsi), %mm7

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
