/*
**  MMXmem benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005-07 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl mmxcp
mmxcp:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %r8
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.precp:
	movq	%r8, 0(%rsi)
	movq	%r8, 8(%rsi)
	movq	%r8, 16(%rsi)
	movq	%r8, 24(%rsi)
	addq	$32, %rsi
	loopq	.precp
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$256, %rax
.maincp:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	movq	%mm0, 0(%rdi)
	movq	%mm1, 8(%rdi)
	movq	%mm2, 16(%rdi)
	movq	%mm3, 24(%rdi)
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	movq	%mm4, 32(%rdi)
	movq	%mm5, 40(%rdi)
	movq	%mm6, 48(%rdi)
	movq	%mm7, 56(%rdi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	movq	%mm0, 64(%rdi)
	movq	%mm1, 72(%rdi)
	movq	%mm2, 80(%rdi)
	movq	%mm3, 88(%rdi)
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	movq	%mm4, 96(%rdi)
	movq	%mm5, 104(%rdi)
	movq	%mm6, 112(%rdi)
	movq	%mm7, 120(%rdi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	movq	%mm0, 128(%rdi)
	movq	%mm1, 136(%rdi)
	movq	%mm2, 144(%rdi)
	movq	%mm3, 152(%rdi)
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	movq	%mm4, 160(%rdi)
	movq	%mm5, 168(%rdi)
	movq	%mm6, 176(%rdi)
	movq	%mm7, 184(%rdi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	movq	%mm0, 192(%rdi)
	movq	%mm1, 200(%rdi)
	movq	%mm2, 208(%rdi)
	movq	%mm3, 216(%rdi)
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movq	%mm4, 224(%rdi)
	movq	%mm5, 232(%rdi)
	movq	%mm6, 240(%rdi)
	movq	%mm7, 248(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxsc
mmxsc:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %r8
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.presc:
	movq	%r8, 0(%rsi)
	movq	%r8, 8(%rsi)
	movq	%r8, 16(%rsi)
	movq	%r8, 24(%rsi)
	addq	$32, %rsi
	loopq	.presc
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$256, %rax
.mainsc:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 0(%rdi)
	movq	%mm1, 8(%rdi)
	movq	%mm2, 16(%rdi)
	movq	%mm3, 24(%rdi)
	movq	32(%rsi), %mm0
	movq	40(%rsi), %mm1
	movq	48(%rsi), %mm2
	movq	56(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 32(%rdi)
	movq	%mm1, 40(%rdi)
	movq	%mm2, 48(%rdi)
	movq	%mm3, 56(%rdi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 64(%rdi)
	movq	%mm1, 72(%rdi)
	movq	%mm2, 80(%rdi)
	movq	%mm3, 88(%rdi)
	movq	96(%rsi), %mm0
	movq	104(%rsi), %mm1
	movq	112(%rsi), %mm2
	movq	120(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 96(%rdi)
	movq	%mm1, 104(%rdi)
	movq	%mm2, 112(%rdi)
	movq	%mm3, 120(%rdi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 128(%rdi)
	movq	%mm1, 136(%rdi)
	movq	%mm2, 144(%rdi)
	movq	%mm3, 152(%rdi)
	movq	160(%rsi), %mm0
	movq	168(%rsi), %mm1
	movq	176(%rsi), %mm2
	movq	184(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 160(%rdi)
	movq	%mm1, 168(%rdi)
	movq	%mm2, 176(%rdi)
	movq	%mm3, 184(%rdi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 192(%rdi)
	movq	%mm1, 200(%rdi)
	movq	%mm2, 208(%rdi)
	movq	%mm3, 216(%rdi)
	movq	224(%rsi), %mm0
	movq	232(%rsi), %mm1
	movq	240(%rsi), %mm2
	movq	248(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movq	%mm0, 224(%rdi)
	movq	%mm1, 232(%rdi)
	movq	%mm2, 240(%rdi)
	movq	%mm3, 248(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxad
mmxad:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %r8
	movq	$0x0037003700370037, %r9
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pread:
	movq	%r8, 0(%rsi)
	movq	%r8, 8(%rsi)
	movq	%r8, 16(%rsi)
	movq	%r8, 24(%rsi)
	movq	%r9, 0(%rbp)
	movq	%r9, 8(%rbp)
	movq	%r9, 16(%rbp)
	movq	%r9, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pread
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$256, %rax
.mainad:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	paddusw	0(%rbp), %mm0
	paddusw	8(%rbp), %mm1
	paddusw	16(%rbp), %mm2
	paddusw	24(%rbp), %mm3
	movq	%mm0, 0(%rdi)
	movq	%mm1, 8(%rdi)
	movq	%mm2, 16(%rdi)
	movq	%mm3, 24(%rdi)
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	paddusw	32(%rbp), %mm4
	paddusw	40(%rbp), %mm5
	paddusw	48(%rbp), %mm6
	paddusw	56(%rbp), %mm7
	movq	%mm4, 32(%rdi)
	movq	%mm5, 40(%rdi)
	movq	%mm6, 48(%rdi)
	movq	%mm7, 56(%rdi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	paddusw	64(%rbp), %mm0
	paddusw	72(%rbp), %mm1
	paddusw	80(%rbp), %mm2
	paddusw	88(%rbp), %mm3
	movq	%mm0, 64(%rdi)
	movq	%mm1, 72(%rdi)
	movq	%mm2, 80(%rdi)
	movq	%mm3, 88(%rdi)
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	paddusw	96(%rbp), %mm4
	paddusw	104(%rbp), %mm5
	paddusw	112(%rbp), %mm6
	paddusw	120(%rbp), %mm7
	movq	%mm4, 96(%rdi)
	movq	%mm5, 104(%rdi)
	movq	%mm6, 112(%rdi)
	movq	%mm7, 120(%rdi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	paddusw	128(%rbp), %mm0
	paddusw	136(%rbp), %mm1
	paddusw	144(%rbp), %mm2
	paddusw	152(%rbp), %mm3
	movq	%mm0, 128(%rdi)
	movq	%mm1, 136(%rdi)
	movq	%mm2, 144(%rdi)
	movq	%mm3, 152(%rdi)
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	paddusw	160(%rbp), %mm4
	paddusw	168(%rbp), %mm5
	paddusw	176(%rbp), %mm6
	paddusw	184(%rbp), %mm7
	movq	%mm4, 160(%rdi)
	movq	%mm5, 168(%rdi)
	movq	%mm6, 176(%rdi)
	movq	%mm7, 184(%rdi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	paddusw	192(%rbp), %mm0
	paddusw	200(%rbp), %mm1
	paddusw	208(%rbp), %mm2
	paddusw	216(%rbp), %mm3
	movq	%mm0, 192(%rdi)
	movq	%mm1, 200(%rdi)
	movq	%mm2, 208(%rdi)
	movq	%mm3, 216(%rdi)
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	paddusw	224(%rbp), %mm4
	paddusw	232(%rbp), %mm5
	paddusw	240(%rbp), %mm6
	paddusw	248(%rbp), %mm7
	movq	%mm4, 224(%rdi)
	movq	%mm5, 232(%rdi)
	movq	%mm6, 240(%rdi)
	movq	%mm7, 248(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxtr
mmxtr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %r8
	movq	$0x0037003700370037, %r9
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pretr:
	movq	%r8, 0(%rsi)
	movq	%r8, 8(%rsi)
	movq	%r8, 16(%rsi)
	movq	%r8, 24(%rsi)
	movq	%r9, 0(%rbp)
	movq	%r9, 8(%rbp)
	movq	%r9, 16(%rbp)
	movq	%r9, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pretr
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$8, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$256, %rax
.maintr:
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%rbp), %mm0
	paddusw	8(%rbp), %mm1
	paddusw	16(%rbp), %mm2
	paddusw	24(%rbp), %mm3
	movq	%mm0, 0(%rdi)
	movq	%mm1, 8(%rdi)
	movq	%mm2, 16(%rdi)
	movq	%mm3, 24(%rdi)
	movq	32(%rsi), %mm0
	movq	40(%rsi), %mm1
	movq	48(%rsi), %mm2
	movq	56(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%rbp), %mm0
	paddusw	40(%rbp), %mm1
	paddusw	48(%rbp), %mm2
	paddusw	56(%rbp), %mm3
	movq	%mm0, 32(%rdi)
	movq	%mm1, 40(%rdi)
	movq	%mm2, 48(%rdi)
	movq	%mm3, 56(%rdi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%rbp), %mm0
	paddusw	72(%rbp), %mm1
	paddusw	80(%rbp), %mm2
	paddusw	88(%rbp), %mm3
	movq	%mm0, 64(%rdi)
	movq	%mm1, 72(%rdi)
	movq	%mm2, 80(%rdi)
	movq	%mm3, 88(%rdi)
	movq	96(%rsi), %mm0
	movq	104(%rsi), %mm1
	movq	112(%rsi), %mm2
	movq	120(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%rbp), %mm0
	paddusw	104(%rbp), %mm1
	paddusw	112(%rbp), %mm2
	paddusw	120(%rbp), %mm3
	movq	%mm0, 96(%rdi)
	movq	%mm1, 104(%rdi)
	movq	%mm2, 112(%rdi)
	movq	%mm3, 120(%rdi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%rbp), %mm0
	paddusw	136(%rbp), %mm1
	paddusw	144(%rbp), %mm2
	paddusw	152(%rbp), %mm3
	movq	%mm0, 128(%rdi)
	movq	%mm1, 136(%rdi)
	movq	%mm2, 144(%rdi)
	movq	%mm3, 152(%rdi)
	movq	160(%rsi), %mm0
	movq	168(%rsi), %mm1
	movq	176(%rsi), %mm2
	movq	184(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%rbp), %mm0
	paddusw	168(%rbp), %mm1
	paddusw	176(%rbp), %mm2
	paddusw	184(%rbp), %mm3
	movq	%mm0, 160(%rdi)
	movq	%mm1, 168(%rdi)
	movq	%mm2, 176(%rdi)
	movq	%mm3, 184(%rdi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%rbp), %mm0
	paddusw	200(%rbp), %mm1
	paddusw	208(%rbp), %mm2
	paddusw	216(%rbp), %mm3
	movq	%mm0, 192(%rdi)
	movq	%mm1, 200(%rdi)
	movq	%mm2, 208(%rdi)
	movq	%mm3, 216(%rdi)
	movq	224(%rsi), %mm0
	movq	232(%rsi), %mm1
	movq	240(%rsi), %mm2
	movq	248(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%rbp), %mm0
	paddusw	232(%rbp), %mm1
	paddusw	240(%rbp), %mm2
	paddusw	248(%rbp), %mm3
	movq	%mm0, 224(%rdi)
	movq	%mm1, 232(%rdi)
	movq	%mm2, 240(%rdi)
	movq	%mm3, 248(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxcp_nt
mmxcp_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.precp_nt:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	addq	$32, %rsi
	loopq	.precp_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.maincp_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	512(%rsi)
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	prefetchnta	576(%rsi)
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	movntq	%mm4, 32(%rdi)
	movntq	%mm5, 40(%rdi)
	movntq	%mm6, 48(%rdi)
	movntq	%mm7, 56(%rdi)
	prefetchnta	640(%rsi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	prefetchnta	704(%rsi)
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	movntq	%mm4, 96(%rdi)
	movntq	%mm5, 104(%rdi)
	movntq	%mm6, 112(%rdi)
	movntq	%mm7, 120(%rdi)
	prefetchnta	768(%rsi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	prefetchnta	832(%rsi)
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	movntq	%mm4, 160(%rdi)
	movntq	%mm5, 168(%rdi)
	movntq	%mm6, 176(%rdi)
	movntq	%mm7, 184(%rdi)
	prefetchnta	896(%rsi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	prefetchnta	960(%rsi)
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	movntq	%mm4, 224(%rdi)
	movntq	%mm5, 232(%rdi)
	movntq	%mm6, 240(%rdi)
	movntq	%mm7, 248(%rdi)
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	movq	288(%rsi), %mm4
	movq	296(%rsi), %mm5
	movq	304(%rsi), %mm6
	movq	312(%rsi), %mm7
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movntq	%mm4, 288(%rdi)
	movntq	%mm5, 296(%rdi)
	movntq	%mm6, 304(%rdi)
	movntq	%mm7, 312(%rdi)
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	movq	352(%rsi), %mm4
	movq	360(%rsi), %mm5
	movq	368(%rsi), %mm6
	movq	376(%rsi), %mm7
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movntq	%mm4, 352(%rdi)
	movntq	%mm5, 360(%rdi)
	movntq	%mm6, 368(%rdi)
	movntq	%mm7, 376(%rdi)
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	movq	416(%rsi), %mm4
	movq	424(%rsi), %mm5
	movq	432(%rsi), %mm6
	movq	440(%rsi), %mm7
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movntq	%mm4, 416(%rdi)
	movntq	%mm5, 424(%rdi)
	movntq	%mm6, 432(%rdi)
	movntq	%mm7, 440(%rdi)
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	movq	480(%rsi), %mm4
	movq	488(%rsi), %mm5
	movq	496(%rsi), %mm6
	movq	504(%rsi), %mm7
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movntq	%mm4, 480(%rdi)
	movntq	%mm5, 488(%rdi)
	movntq	%mm6, 496(%rdi)
	movntq	%mm7, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp_nt

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxsc_nt
mmxsc_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.presc_nt:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	addq	$32, %rsi
	loopq	.presc_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.mainsc_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	512(%rsi)
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	prefetchnta	576(%rsi)
	movq	32(%rsi), %mm0
	movq	40(%rsi), %mm1
	movq	48(%rsi), %mm2
	movq	56(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%rdi)
	movntq	%mm1, 40(%rdi)
	movntq	%mm2, 48(%rdi)
	movntq	%mm3, 56(%rdi)
	prefetchnta	640(%rsi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	prefetchnta	704(%rsi)
	movq	96(%rsi), %mm0
	movq	104(%rsi), %mm1
	movq	112(%rsi), %mm2
	movq	120(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%rdi)
	movntq	%mm1, 104(%rdi)
	movntq	%mm2, 112(%rdi)
	movntq	%mm3, 120(%rdi)
	prefetchnta	768(%rsi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	prefetchnta	832(%rsi)
	movq	160(%rsi), %mm0
	movq	168(%rsi), %mm1
	movq	176(%rsi), %mm2
	movq	184(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%rdi)
	movntq	%mm1, 168(%rdi)
	movntq	%mm2, 176(%rdi)
	movntq	%mm3, 184(%rdi)
	prefetchnta	896(%rsi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	prefetchnta	960(%rsi)
	movq	224(%rsi), %mm0
	movq	232(%rsi), %mm1
	movq	240(%rsi), %mm2
	movq	248(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%rdi)
	movntq	%mm1, 232(%rdi)
	movntq	%mm2, 240(%rdi)
	movntq	%mm3, 248(%rdi)
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movq	288(%rsi), %mm0
	movq	296(%rsi), %mm1
	movq	304(%rsi), %mm2
	movq	312(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 288(%rdi)
	movntq	%mm1, 296(%rdi)
	movntq	%mm2, 304(%rdi)
	movntq	%mm3, 312(%rdi)
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movq	352(%rsi), %mm0
	movq	360(%rsi), %mm1
	movq	368(%rsi), %mm2
	movq	376(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 352(%rdi)
	movntq	%mm1, 360(%rdi)
	movntq	%mm2, 368(%rdi)
	movntq	%mm3, 376(%rdi)
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movq	416(%rsi), %mm0
	movq	424(%rsi), %mm1
	movq	432(%rsi), %mm2
	movq	440(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 416(%rdi)
	movntq	%mm1, 424(%rdi)
	movntq	%mm2, 432(%rdi)
	movntq	%mm3, 440(%rdi)
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movq	480(%rsi), %mm0
	movq	488(%rsi), %mm1
	movq	496(%rsi), %mm2
	movq	504(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 480(%rdi)
	movntq	%mm1, 488(%rdi)
	movntq	%mm2, 496(%rdi)
	movntq	%mm3, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc_nt

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxad_nt
mmxad_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	$0x0037003700370037, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm1
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pread_nt:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	movntq	%mm0, 0(%rbp)
	movntq	%mm0, 8(%rbp)
	movntq	%mm0, 16(%rbp)
	movntq	%mm0, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pread_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.mainad_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	512(%rbp)
	movq	0(%rbp), %mm0
	movq	8(%rbp), %mm1
	movq	16(%rbp), %mm2
	movq	24(%rbp), %mm3
	prefetchnta	512(%rsi)
	movq	32(%rbp), %mm4
	movq	40(%rbp), %mm5
	movq	48(%rbp), %mm6
	movq	56(%rbp), %mm7
	prefetchnta	576(%rbp)
	paddusw	0(%rsi), %mm0
	paddusw	8(%rsi), %mm1
	paddusw	16(%rsi), %mm2
	paddusw	24(%rsi), %mm3
	prefetchnta	576(%rsi)
	paddusw	32(%rsi), %mm4
	paddusw	40(%rsi), %mm5
	paddusw	48(%rsi), %mm6
	paddusw	56(%rsi), %mm7
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	movntq	%mm4, 32(%rdi)
	movntq	%mm5, 40(%rdi)
	movntq	%mm6, 48(%rdi)
	movntq	%mm7, 56(%rdi)
	prefetchnta	640(%rbp)
	movq	64(%rbp), %mm0
	movq	72(%rbp), %mm1
	movq	80(%rbp), %mm2
	movq	88(%rbp), %mm3
	prefetchnta	640(%rsi)
	movq	96(%rbp), %mm4
	movq	104(%rbp), %mm5
	movq	112(%rbp), %mm6
	movq	120(%rbp), %mm7
	prefetchnta	704(%rbp)
	paddusw	64(%rsi), %mm0
	paddusw	72(%rsi), %mm1
	paddusw	80(%rsi), %mm2
	paddusw	88(%rsi), %mm3
	prefetchnta	704(%rsi)
	paddusw	96(%rsi), %mm4
	paddusw	104(%rsi), %mm5
	paddusw	112(%rsi), %mm6
	paddusw	120(%rsi), %mm7
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	movntq	%mm4, 96(%rdi)
	movntq	%mm5, 104(%rdi)
	movntq	%mm6, 112(%rdi)
	movntq	%mm7, 120(%rdi)
	prefetchnta	768(%rbp)
	movq	128(%rbp), %mm0
	movq	136(%rbp), %mm1
	movq	144(%rbp), %mm2
	movq	152(%rbp), %mm3
	prefetchnta	768(%rsi)
	movq	160(%rbp), %mm4
	movq	168(%rbp), %mm5
	movq	176(%rbp), %mm6
	movq	184(%rbp), %mm7
	prefetchnta	832(%rbp)
	paddusw	128(%rsi), %mm0
	paddusw	136(%rsi), %mm1
	paddusw	144(%rsi), %mm2
	paddusw	152(%rsi), %mm3
	prefetchnta	832(%rsi)
	paddusw	160(%rsi), %mm4
	paddusw	168(%rsi), %mm5
	paddusw	176(%rsi), %mm6
	paddusw	184(%rsi), %mm7
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	movntq	%mm4, 160(%rdi)
	movntq	%mm5, 168(%rdi)
	movntq	%mm6, 176(%rdi)
	movntq	%mm7, 184(%rdi)
	prefetchnta	896(%rbp)
	movq	192(%rbp), %mm0
	movq	200(%rbp), %mm1
	movq	208(%rbp), %mm2
	movq	216(%rbp), %mm3
	prefetchnta	896(%rsi)
	movq	224(%rbp), %mm4
	movq	232(%rbp), %mm5
	movq	240(%rbp), %mm6
	movq	248(%rbp), %mm7
	prefetchnta	960(%rbp)
	paddusw	192(%rsi), %mm0
	paddusw	200(%rsi), %mm1
	paddusw	208(%rsi), %mm2
	paddusw	216(%rsi), %mm3
	prefetchnta	960(%rsi)
	paddusw	224(%rsi), %mm4
	paddusw	232(%rsi), %mm5
	paddusw	240(%rsi), %mm6
	paddusw	248(%rsi), %mm7
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	movntq	%mm4, 224(%rdi)
	movntq	%mm5, 232(%rdi)
	movntq	%mm6, 240(%rdi)
	movntq	%mm7, 248(%rdi)
	movq	256(%rbp), %mm0
	movq	264(%rbp), %mm1
	movq	272(%rbp), %mm2
	movq	280(%rbp), %mm3
	movq	288(%rbp), %mm4
	movq	296(%rbp), %mm5
	movq	304(%rbp), %mm6
	movq	312(%rbp), %mm7
	paddusw	256(%rsi), %mm0
	paddusw	264(%rsi), %mm1
	paddusw	272(%rsi), %mm2
	paddusw	280(%rsi), %mm3
	paddusw	288(%rsi), %mm4
	paddusw	296(%rsi), %mm5
	paddusw	304(%rsi), %mm6
	paddusw	312(%rsi), %mm7
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movntq	%mm4, 288(%rdi)
	movntq	%mm5, 296(%rdi)
	movntq	%mm6, 304(%rdi)
	movntq	%mm7, 312(%rdi)
	movq	320(%rbp), %mm0
	movq	328(%rbp), %mm1
	movq	336(%rbp), %mm2
	movq	344(%rbp), %mm3
	movq	352(%rbp), %mm4
	movq	360(%rbp), %mm5
	movq	368(%rbp), %mm6
	movq	376(%rbp), %mm7
	paddusw	320(%rsi), %mm0
	paddusw	328(%rsi), %mm1
	paddusw	336(%rsi), %mm2
	paddusw	344(%rsi), %mm3
	paddusw	352(%rsi), %mm4
	paddusw	360(%rsi), %mm5
	paddusw	368(%rsi), %mm6
	paddusw	376(%rsi), %mm7
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movntq	%mm4, 352(%rdi)
	movntq	%mm5, 360(%rdi)
	movntq	%mm6, 368(%rdi)
	movntq	%mm7, 376(%rdi)
	movq	384(%rbp), %mm0
	movq	392(%rbp), %mm1
	movq	400(%rbp), %mm2
	movq	408(%rbp), %mm3
	movq	416(%rbp), %mm4
	movq	424(%rbp), %mm5
	movq	432(%rbp), %mm6
	movq	440(%rbp), %mm7
	paddusw	384(%rsi), %mm0
	paddusw	392(%rsi), %mm1
	paddusw	400(%rsi), %mm2
	paddusw	408(%rsi), %mm3
	paddusw	416(%rsi), %mm4
	paddusw	424(%rsi), %mm5
	paddusw	432(%rsi), %mm6
	paddusw	440(%rsi), %mm7
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movntq	%mm4, 416(%rdi)
	movntq	%mm5, 424(%rdi)
	movntq	%mm6, 432(%rdi)
	movntq	%mm7, 440(%rdi)
	movq	448(%rbp), %mm0
	movq	456(%rbp), %mm1
	movq	464(%rbp), %mm2
	movq	472(%rbp), %mm3
	movq	480(%rbp), %mm4
	movq	488(%rbp), %mm5
	movq	496(%rbp), %mm6
	movq	504(%rbp), %mm7
	paddusw	448(%rsi), %mm0
	paddusw	456(%rsi), %mm1
	paddusw	464(%rsi), %mm2
	paddusw	472(%rsi), %mm3
	paddusw	480(%rsi), %mm4
	paddusw	488(%rsi), %mm5
	paddusw	496(%rsi), %mm6
	paddusw	504(%rsi), %mm7
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movntq	%mm4, 480(%rdi)
	movntq	%mm5, 488(%rdi)
	movntq	%mm6, 496(%rdi)
	movntq	%mm7, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad_nt

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxtr_nt
mmxtr_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	$0x0037003700370037, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm1
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pretr_nt:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	movntq	%mm0, 0(%rbp)
	movntq	%mm0, 8(%rbp)
	movntq	%mm0, 16(%rbp)
	movntq	%mm0, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pretr_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.maintr_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	512(%rbp)
	movq	0(%rbp), %mm0
	movq	8(%rbp), %mm1
	movq	16(%rbp), %mm2
	movq	24(%rbp), %mm3
	prefetchnta	512(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%rsi), %mm0
	paddusw	8(%rsi), %mm1
	paddusw	16(%rsi), %mm2
	paddusw	24(%rsi), %mm3
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	prefetchnta	576(%rbp)
	movq	32(%rbp), %mm0
	movq	40(%rbp), %mm1
	movq	48(%rbp), %mm2
	movq	56(%rbp), %mm3
	prefetchnta	576(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%rsi), %mm0
	paddusw	40(%rsi), %mm1
	paddusw	48(%rsi), %mm2
	paddusw	56(%rsi), %mm3
	movntq	%mm0, 32(%rdi)
	movntq	%mm1, 40(%rdi)
	movntq	%mm2, 48(%rdi)
	movntq	%mm3, 56(%rdi)
	prefetchnta	640(%rbp)
	movq	64(%rbp), %mm0
	movq	72(%rbp), %mm1
	movq	80(%rbp), %mm2
	movq	88(%rbp), %mm3
	prefetchnta	640(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%rsi), %mm0
	paddusw	72(%rsi), %mm1
	paddusw	80(%rsi), %mm2
	paddusw	88(%rsi), %mm3
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	prefetchnta	704(%rbp)
	movq	96(%rbp), %mm0
	movq	104(%rbp), %mm1
	movq	112(%rbp), %mm2
	movq	120(%rbp), %mm3
	prefetchnta	704(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%rsi), %mm0
	paddusw	104(%rsi), %mm1
	paddusw	112(%rsi), %mm2
	paddusw	120(%rsi), %mm3
	movntq	%mm0, 96(%rdi)
	movntq	%mm1, 104(%rdi)
	movntq	%mm2, 112(%rdi)
	movntq	%mm3, 120(%rdi)
	prefetchnta	768(%rbp)
	movq	128(%rbp), %mm0
	movq	136(%rbp), %mm1
	movq	144(%rbp), %mm2
	movq	152(%rbp), %mm3
	prefetchnta	768(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%rsi), %mm0
	paddusw	136(%rsi), %mm1
	paddusw	144(%rsi), %mm2
	paddusw	152(%rsi), %mm3
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	prefetchnta	832(%rbp)
	movq	160(%rbp), %mm0
	movq	168(%rbp), %mm1
	movq	176(%rbp), %mm2
	movq	184(%rbp), %mm3
	prefetchnta	832(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%rsi), %mm0
	paddusw	168(%rsi), %mm1
	paddusw	176(%rsi), %mm2
	paddusw	184(%rsi), %mm3
	movntq	%mm0, 160(%rdi)
	movntq	%mm1, 168(%rdi)
	movntq	%mm2, 176(%rdi)
	movntq	%mm3, 184(%rdi)
	prefetchnta	896(%rbp)
	movq	192(%rbp), %mm0
	movq	200(%rbp), %mm1
	movq	208(%rbp), %mm2
	movq	216(%rbp), %mm3
	prefetchnta	896(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%rsi), %mm0
	paddusw	200(%rsi), %mm1
	paddusw	208(%rsi), %mm2
	paddusw	216(%rsi), %mm3
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	prefetchnta	960(%rbp)
	movq	224(%rbp), %mm0
	movq	232(%rbp), %mm1
	movq	240(%rbp), %mm2
	movq	248(%rbp), %mm3
	prefetchnta	960(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%rsi), %mm0
	paddusw	232(%rsi), %mm1
	paddusw	240(%rsi), %mm2
	paddusw	248(%rsi), %mm3
	movntq	%mm0, 224(%rdi)
	movntq	%mm1, 232(%rdi)
	movntq	%mm2, 240(%rdi)
	movntq	%mm3, 248(%rdi)
	movq	256(%rbp), %mm0
	movq	264(%rbp), %mm1
	movq	272(%rbp), %mm2
	movq	280(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	256(%rsi), %mm0
	paddusw	264(%rsi), %mm1
	paddusw	272(%rsi), %mm2
	paddusw	280(%rsi), %mm3
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movq	288(%rbp), %mm0
	movq	296(%rbp), %mm1
	movq	304(%rbp), %mm2
	movq	312(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	288(%rsi), %mm0
	paddusw	296(%rsi), %mm1
	paddusw	304(%rsi), %mm2
	paddusw	312(%rsi), %mm3
	movntq	%mm0, 288(%rdi)
	movntq	%mm1, 296(%rdi)
	movntq	%mm2, 304(%rdi)
	movntq	%mm3, 312(%rdi)
	movq	320(%rbp), %mm0
	movq	328(%rbp), %mm1
	movq	336(%rbp), %mm2
	movq	344(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	320(%rsi), %mm0
	paddusw	328(%rsi), %mm1
	paddusw	336(%rsi), %mm2
	paddusw	344(%rsi), %mm3
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movq	352(%rbp), %mm0
	movq	360(%rbp), %mm1
	movq	368(%rbp), %mm2
	movq	376(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	352(%rsi), %mm0
	paddusw	360(%rsi), %mm1
	paddusw	368(%rsi), %mm2
	paddusw	376(%rsi), %mm3
	movntq	%mm0, 352(%rdi)
	movntq	%mm1, 360(%rdi)
	movntq	%mm2, 368(%rdi)
	movntq	%mm3, 376(%rdi)
	movq	384(%rbp), %mm0
	movq	392(%rbp), %mm1
	movq	400(%rbp), %mm2
	movq	408(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	384(%rsi), %mm0
	paddusw	392(%rsi), %mm1
	paddusw	400(%rsi), %mm2
	paddusw	408(%rsi), %mm3
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movq	416(%rbp), %mm0
	movq	424(%rbp), %mm1
	movq	432(%rbp), %mm2
	movq	440(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	416(%rsi), %mm0
	paddusw	424(%rsi), %mm1
	paddusw	432(%rsi), %mm2
	paddusw	440(%rsi), %mm3
	movntq	%mm0, 416(%rdi)
	movntq	%mm1, 424(%rdi)
	movntq	%mm2, 432(%rdi)
	movntq	%mm3, 440(%rdi)
	movq	448(%rbp), %mm0
	movq	456(%rbp), %mm1
	movq	464(%rbp), %mm2
	movq	472(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	448(%rsi), %mm0
	paddusw	456(%rsi), %mm1
	paddusw	464(%rsi), %mm2
	paddusw	472(%rsi), %mm3
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movq	480(%rbp), %mm0
	movq	488(%rbp), %mm1
	movq	496(%rbp), %mm2
	movq	504(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	480(%rsi), %mm0
	paddusw	488(%rsi), %mm1
	paddusw	496(%rsi), %mm2
	paddusw	504(%rsi), %mm3
	movntq	%mm0, 480(%rdi)
	movntq	%mm1, 488(%rdi)
	movntq	%mm2, 496(%rdi)
	movntq	%mm3, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr_nt

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxcp_nt_t0
mmxcp_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.precp_nt_t0:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	addq	$32, %rsi
	loopq	.precp_nt_t0
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.maincp_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	512(%rsi)
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	prefetcht0	576(%rsi)
	movq	32(%rsi), %mm4
	movq	40(%rsi), %mm5
	movq	48(%rsi), %mm6
	movq	56(%rsi), %mm7
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	movntq	%mm4, 32(%rdi)
	movntq	%mm5, 40(%rdi)
	movntq	%mm6, 48(%rdi)
	movntq	%mm7, 56(%rdi)
	prefetcht0	640(%rsi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	prefetcht0	704(%rsi)
	movq	96(%rsi), %mm4
	movq	104(%rsi), %mm5
	movq	112(%rsi), %mm6
	movq	120(%rsi), %mm7
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	movntq	%mm4, 96(%rdi)
	movntq	%mm5, 104(%rdi)
	movntq	%mm6, 112(%rdi)
	movntq	%mm7, 120(%rdi)
	prefetcht0	768(%rsi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	prefetcht0	832(%rsi)
	movq	160(%rsi), %mm4
	movq	168(%rsi), %mm5
	movq	176(%rsi), %mm6
	movq	184(%rsi), %mm7
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	movntq	%mm4, 160(%rdi)
	movntq	%mm5, 168(%rdi)
	movntq	%mm6, 176(%rdi)
	movntq	%mm7, 184(%rdi)
	prefetcht0	896(%rsi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	prefetcht0	960(%rsi)
	movq	224(%rsi), %mm4
	movq	232(%rsi), %mm5
	movq	240(%rsi), %mm6
	movq	248(%rsi), %mm7
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	movntq	%mm4, 224(%rdi)
	movntq	%mm5, 232(%rdi)
	movntq	%mm6, 240(%rdi)
	movntq	%mm7, 248(%rdi)
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	movq	288(%rsi), %mm4
	movq	296(%rsi), %mm5
	movq	304(%rsi), %mm6
	movq	312(%rsi), %mm7
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movntq	%mm4, 288(%rdi)
	movntq	%mm5, 296(%rdi)
	movntq	%mm6, 304(%rdi)
	movntq	%mm7, 312(%rdi)
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	movq	352(%rsi), %mm4
	movq	360(%rsi), %mm5
	movq	368(%rsi), %mm6
	movq	376(%rsi), %mm7
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movntq	%mm4, 352(%rdi)
	movntq	%mm5, 360(%rdi)
	movntq	%mm6, 368(%rdi)
	movntq	%mm7, 376(%rdi)
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	movq	416(%rsi), %mm4
	movq	424(%rsi), %mm5
	movq	432(%rsi), %mm6
	movq	440(%rsi), %mm7
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movntq	%mm4, 416(%rdi)
	movntq	%mm5, 424(%rdi)
	movntq	%mm6, 432(%rdi)
	movntq	%mm7, 440(%rdi)
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	movq	480(%rsi), %mm4
	movq	488(%rsi), %mm5
	movq	496(%rsi), %mm6
	movq	504(%rsi), %mm7
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movntq	%mm4, 480(%rdi)
	movntq	%mm5, 488(%rdi)
	movntq	%mm6, 496(%rdi)
	movntq	%mm7, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxsc_nt_t0
mmxsc_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
.presc_nt_t0:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	addq	$32, %rsi
	loopq	.presc_nt_t0
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.mainsc_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	512(%rsi)
	movq	0(%rsi), %mm0
	movq	8(%rsi), %mm1
	movq	16(%rsi), %mm2
	movq	24(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	prefetcht0	576(%rsi)
	movq	32(%rsi), %mm0
	movq	40(%rsi), %mm1
	movq	48(%rsi), %mm2
	movq	56(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 32(%rdi)
	movntq	%mm1, 40(%rdi)
	movntq	%mm2, 48(%rdi)
	movntq	%mm3, 56(%rdi)
	prefetcht0	640(%rsi)
	movq	64(%rsi), %mm0
	movq	72(%rsi), %mm1
	movq	80(%rsi), %mm2
	movq	88(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	prefetcht0	704(%rsi)
	movq	96(%rsi), %mm0
	movq	104(%rsi), %mm1
	movq	112(%rsi), %mm2
	movq	120(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 96(%rdi)
	movntq	%mm1, 104(%rdi)
	movntq	%mm2, 112(%rdi)
	movntq	%mm3, 120(%rdi)
	prefetcht0	768(%rsi)
	movq	128(%rsi), %mm0
	movq	136(%rsi), %mm1
	movq	144(%rsi), %mm2
	movq	152(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	prefetcht0	832(%rsi)
	movq	160(%rsi), %mm0
	movq	168(%rsi), %mm1
	movq	176(%rsi), %mm2
	movq	184(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 160(%rdi)
	movntq	%mm1, 168(%rdi)
	movntq	%mm2, 176(%rdi)
	movntq	%mm3, 184(%rdi)
	prefetcht0	896(%rsi)
	movq	192(%rsi), %mm0
	movq	200(%rsi), %mm1
	movq	208(%rsi), %mm2
	movq	216(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	prefetcht0	960(%rsi)
	movq	224(%rsi), %mm0
	movq	232(%rsi), %mm1
	movq	240(%rsi), %mm2
	movq	248(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 224(%rdi)
	movntq	%mm1, 232(%rdi)
	movntq	%mm2, 240(%rdi)
	movntq	%mm3, 248(%rdi)
	movq	256(%rsi), %mm0
	movq	264(%rsi), %mm1
	movq	272(%rsi), %mm2
	movq	280(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)	
	movq	288(%rsi), %mm0
	movq	296(%rsi), %mm1
	movq	304(%rsi), %mm2
	movq	312(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 288(%rdi)
	movntq	%mm1, 296(%rdi)
	movntq	%mm2, 304(%rdi)
	movntq	%mm3, 312(%rdi)
	movq	320(%rsi), %mm0
	movq	328(%rsi), %mm1
	movq	336(%rsi), %mm2
	movq	344(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movq	352(%rsi), %mm0
	movq	360(%rsi), %mm1
	movq	368(%rsi), %mm2
	movq	376(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 352(%rdi)
	movntq	%mm1, 360(%rdi)
	movntq	%mm2, 368(%rdi)
	movntq	%mm3, 376(%rdi)
	movq	384(%rsi), %mm0
	movq	392(%rsi), %mm1
	movq	400(%rsi), %mm2
	movq	408(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movq	416(%rsi), %mm0
	movq	424(%rsi), %mm1
	movq	432(%rsi), %mm2
	movq	440(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 416(%rdi)
	movntq	%mm1, 424(%rdi)
	movntq	%mm2, 432(%rdi)
	movntq	%mm3, 440(%rdi)
	movq	448(%rsi), %mm0
	movq	456(%rsi), %mm1
	movq	464(%rsi), %mm2
	movq	472(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movq	480(%rsi), %mm0
	movq	488(%rsi), %mm1
	movq	496(%rsi), %mm2
	movq	504(%rsi), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	movntq	%mm0, 480(%rdi)
	movntq	%mm1, 488(%rdi)
	movntq	%mm2, 496(%rdi)
	movntq	%mm3, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxad_nt_t0
mmxad_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	$0x0037003700370037, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm1
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pread_nt_t0:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	movntq	%mm0, 0(%rbp)
	movntq	%mm0, 8(%rbp)
	movntq	%mm0, 16(%rbp)
	movntq	%mm0, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pread_nt_t0
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.mainad_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	512(%rbp)
	movq	0(%rbp), %mm0
	movq	8(%rbp), %mm1
	movq	16(%rbp), %mm2
	movq	24(%rbp), %mm3
	prefetcht0	512(%rsi)
	movq	32(%rbp), %mm4
	movq	40(%rbp), %mm5
	movq	48(%rbp), %mm6
	movq	56(%rbp), %mm7
	prefetcht0	576(%rbp)
	paddusw	0(%rsi), %mm0
	paddusw	8(%rsi), %mm1
	paddusw	16(%rsi), %mm2
	paddusw	24(%rsi), %mm3
	prefetcht0	576(%rsi)
	paddusw	32(%rsi), %mm4
	paddusw	40(%rsi), %mm5
	paddusw	48(%rsi), %mm6
	paddusw	56(%rsi), %mm7
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	movntq	%mm4, 32(%rdi)
	movntq	%mm5, 40(%rdi)
	movntq	%mm6, 48(%rdi)
	movntq	%mm7, 56(%rdi)
	prefetcht0	640(%rbp)
	movq	64(%rbp), %mm0
	movq	72(%rbp), %mm1
	movq	80(%rbp), %mm2
	movq	88(%rbp), %mm3
	prefetcht0	640(%rsi)
	movq	96(%rbp), %mm4
	movq	104(%rbp), %mm5
	movq	112(%rbp), %mm6
	movq	120(%rbp), %mm7
	prefetcht0	704(%rbp)
	paddusw	64(%rsi), %mm0
	paddusw	72(%rsi), %mm1
	paddusw	80(%rsi), %mm2
	paddusw	88(%rsi), %mm3
	prefetcht0	704(%rsi)
	paddusw	96(%rsi), %mm4
	paddusw	104(%rsi), %mm5
	paddusw	112(%rsi), %mm6
	paddusw	120(%rsi), %mm7
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	movntq	%mm4, 96(%rdi)
	movntq	%mm5, 104(%rdi)
	movntq	%mm6, 112(%rdi)
	movntq	%mm7, 120(%rdi)
	prefetcht0	768(%rbp)
	movq	128(%rbp), %mm0
	movq	136(%rbp), %mm1
	movq	144(%rbp), %mm2
	movq	152(%rbp), %mm3
	prefetcht0	768(%rsi)
	movq	160(%rbp), %mm4
	movq	168(%rbp), %mm5
	movq	176(%rbp), %mm6
	movq	184(%rbp), %mm7
	prefetcht0	832(%rbp)
	paddusw	128(%rsi), %mm0
	paddusw	136(%rsi), %mm1
	paddusw	144(%rsi), %mm2
	paddusw	152(%rsi), %mm3
	prefetcht0	832(%rsi)
	paddusw	160(%rsi), %mm4
	paddusw	168(%rsi), %mm5
	paddusw	176(%rsi), %mm6
	paddusw	184(%rsi), %mm7
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	movntq	%mm4, 160(%rdi)
	movntq	%mm5, 168(%rdi)
	movntq	%mm6, 176(%rdi)
	movntq	%mm7, 184(%rdi)
	prefetcht0	896(%rbp)
	movq	192(%rbp), %mm0
	movq	200(%rbp), %mm1
	movq	208(%rbp), %mm2
	movq	216(%rbp), %mm3
	prefetcht0	896(%rsi)
	movq	224(%rbp), %mm4
	movq	232(%rbp), %mm5
	movq	240(%rbp), %mm6
	movq	248(%rbp), %mm7
	prefetcht0	960(%rbp)
	paddusw	192(%rsi), %mm0
	paddusw	200(%rsi), %mm1
	paddusw	208(%rsi), %mm2
	paddusw	216(%rsi), %mm3
	prefetcht0	960(%rsi)
	paddusw	224(%rsi), %mm4
	paddusw	232(%rsi), %mm5
	paddusw	240(%rsi), %mm6
	paddusw	248(%rsi), %mm7
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	movntq	%mm4, 224(%rdi)
	movntq	%mm5, 232(%rdi)
	movntq	%mm6, 240(%rdi)
	movntq	%mm7, 248(%rdi)
	movq	256(%rbp), %mm0
	movq	264(%rbp), %mm1
	movq	272(%rbp), %mm2
	movq	280(%rbp), %mm3
	movq	288(%rbp), %mm4
	movq	296(%rbp), %mm5
	movq	304(%rbp), %mm6
	movq	312(%rbp), %mm7
	paddusw	256(%rsi), %mm0
	paddusw	264(%rsi), %mm1
	paddusw	272(%rsi), %mm2
	paddusw	280(%rsi), %mm3
	paddusw	288(%rsi), %mm4
	paddusw	296(%rsi), %mm5
	paddusw	304(%rsi), %mm6
	paddusw	312(%rsi), %mm7
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movntq	%mm4, 288(%rdi)
	movntq	%mm5, 296(%rdi)
	movntq	%mm6, 304(%rdi)
	movntq	%mm7, 312(%rdi)
	movq	320(%rbp), %mm0
	movq	328(%rbp), %mm1
	movq	336(%rbp), %mm2
	movq	344(%rbp), %mm3
	movq	352(%rbp), %mm4
	movq	360(%rbp), %mm5
	movq	368(%rbp), %mm6
	movq	376(%rbp), %mm7
	paddusw	320(%rsi), %mm0
	paddusw	328(%rsi), %mm1
	paddusw	336(%rsi), %mm2
	paddusw	344(%rsi), %mm3
	paddusw	352(%rsi), %mm4
	paddusw	360(%rsi), %mm5
	paddusw	368(%rsi), %mm6
	paddusw	376(%rsi), %mm7
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movntq	%mm4, 352(%rdi)
	movntq	%mm5, 360(%rdi)
	movntq	%mm6, 368(%rdi)
	movntq	%mm7, 376(%rdi)
	movq	384(%rbp), %mm0
	movq	392(%rbp), %mm1
	movq	400(%rbp), %mm2
	movq	408(%rbp), %mm3
	movq	416(%rbp), %mm4
	movq	424(%rbp), %mm5
	movq	432(%rbp), %mm6
	movq	440(%rbp), %mm7
	paddusw	384(%rsi), %mm0
	paddusw	392(%rsi), %mm1
	paddusw	400(%rsi), %mm2
	paddusw	408(%rsi), %mm3
	paddusw	416(%rsi), %mm4
	paddusw	424(%rsi), %mm5
	paddusw	432(%rsi), %mm6
	paddusw	440(%rsi), %mm7
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movntq	%mm4, 416(%rdi)
	movntq	%mm5, 424(%rdi)
	movntq	%mm6, 432(%rdi)
	movntq	%mm7, 440(%rdi)
	movq	448(%rbp), %mm0
	movq	456(%rbp), %mm1
	movq	464(%rbp), %mm2
	movq	472(%rbp), %mm3
	movq	480(%rbp), %mm4
	movq	488(%rbp), %mm5
	movq	496(%rbp), %mm6
	movq	504(%rbp), %mm7
	paddusw	448(%rsi), %mm0
	paddusw	456(%rsi), %mm1
	paddusw	464(%rsi), %mm2
	paddusw	472(%rsi), %mm3
	paddusw	480(%rsi), %mm4
	paddusw	488(%rsi), %mm5
	paddusw	496(%rsi), %mm6
	paddusw	504(%rsi), %mm7
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movntq	%mm4, 480(%rdi)
	movntq	%mm5, 488(%rdi)
	movntq	%mm6, 496(%rdi)
	movntq	%mm7, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl mmxtr_nt_t0
mmxtr_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	$0x0021002100210021, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm0
	movq	$0x0037003700370037, %rax
	movq	%rax, 0(%rsp)
	movq	0(%rsp), %mm1
	movq	%rbx, %rcx
	shrq	$5, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
.pretr_nt_t0:
	movntq	%mm0, 0(%rsi)
	movntq	%mm0, 8(%rsi)
	movntq	%mm0, 16(%rsi)
	movntq	%mm0, 24(%rsi)
	movntq	%mm0, 0(%rbp)
	movntq	%mm0, 8(%rbp)
	movntq	%mm0, 16(%rbp)
	movntq	%mm0, 24(%rbp)
	addq	$32, %rsi
	addq	$32, %rbp
	loopq	.pretr_nt_t0
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	movw	$77, 16(%rsp)
	movw	$77, 18(%rsp)
	movw	$77, 20(%rsp)
	movw	$77, 22(%rsp)
	movq	16(%rsp), %mm4
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.maintr_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	512(%rbp)
	movq	0(%rbp), %mm0
	movq	8(%rbp), %mm1
	movq	16(%rbp), %mm2
	movq	24(%rbp), %mm3
	prefetcht0	512(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	0(%rsi), %mm0
	paddusw	8(%rsi), %mm1
	paddusw	16(%rsi), %mm2
	paddusw	24(%rsi), %mm3
	movntq	%mm0, 0(%rdi)
	movntq	%mm1, 8(%rdi)
	movntq	%mm2, 16(%rdi)
	movntq	%mm3, 24(%rdi)
	prefetcht0	576(%rbp)
	movq	32(%rbp), %mm0
	movq	40(%rbp), %mm1
	movq	48(%rbp), %mm2
	movq	56(%rbp), %mm3
	prefetcht0	576(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	32(%rsi), %mm0
	paddusw	40(%rsi), %mm1
	paddusw	48(%rsi), %mm2
	paddusw	56(%rsi), %mm3
	movntq	%mm0, 32(%rdi)
	movntq	%mm1, 40(%rdi)
	movntq	%mm2, 48(%rdi)
	movntq	%mm3, 56(%rdi)
	prefetcht0	640(%rbp)
	movq	64(%rbp), %mm0
	movq	72(%rbp), %mm1
	movq	80(%rbp), %mm2
	movq	88(%rbp), %mm3
	prefetcht0	640(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	64(%rsi), %mm0
	paddusw	72(%rsi), %mm1
	paddusw	80(%rsi), %mm2
	paddusw	88(%rsi), %mm3
	movntq	%mm0, 64(%rdi)
	movntq	%mm1, 72(%rdi)
	movntq	%mm2, 80(%rdi)
	movntq	%mm3, 88(%rdi)
	prefetcht0	704(%rbp)
	movq	96(%rbp), %mm0
	movq	104(%rbp), %mm1
	movq	112(%rbp), %mm2
	movq	120(%rbp), %mm3
	prefetcht0	704(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	96(%rsi), %mm0
	paddusw	104(%rsi), %mm1
	paddusw	112(%rsi), %mm2
	paddusw	120(%rsi), %mm3
	movntq	%mm0, 96(%rdi)
	movntq	%mm1, 104(%rdi)
	movntq	%mm2, 112(%rdi)
	movntq	%mm3, 120(%rdi)
	prefetcht0	768(%rbp)
	movq	128(%rbp), %mm0
	movq	136(%rbp), %mm1
	movq	144(%rbp), %mm2
	movq	152(%rbp), %mm3
	prefetcht0	768(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	128(%rsi), %mm0
	paddusw	136(%rsi), %mm1
	paddusw	144(%rsi), %mm2
	paddusw	152(%rsi), %mm3
	movntq	%mm0, 128(%rdi)
	movntq	%mm1, 136(%rdi)
	movntq	%mm2, 144(%rdi)
	movntq	%mm3, 152(%rdi)
	prefetcht0	832(%rbp)
	movq	160(%rbp), %mm0
	movq	168(%rbp), %mm1
	movq	176(%rbp), %mm2
	movq	184(%rbp), %mm3
	prefetcht0	832(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	160(%rsi), %mm0
	paddusw	168(%rsi), %mm1
	paddusw	176(%rsi), %mm2
	paddusw	184(%rsi), %mm3
	movntq	%mm0, 160(%rdi)
	movntq	%mm1, 168(%rdi)
	movntq	%mm2, 176(%rdi)
	movntq	%mm3, 184(%rdi)
	prefetcht0	896(%rbp)
	movq	192(%rbp), %mm0
	movq	200(%rbp), %mm1
	movq	208(%rbp), %mm2
	movq	216(%rbp), %mm3
	prefetcht0	896(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	192(%rsi), %mm0
	paddusw	200(%rsi), %mm1
	paddusw	208(%rsi), %mm2
	paddusw	216(%rsi), %mm3
	movntq	%mm0, 192(%rdi)
	movntq	%mm1, 200(%rdi)
	movntq	%mm2, 208(%rdi)
	movntq	%mm3, 216(%rdi)
	prefetcht0	960(%rbp)
	movq	224(%rbp), %mm0
	movq	232(%rbp), %mm1
	movq	240(%rbp), %mm2
	movq	248(%rbp), %mm3
	prefetcht0	960(%rsi)
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	224(%rsi), %mm0
	paddusw	232(%rsi), %mm1
	paddusw	240(%rsi), %mm2
	paddusw	248(%rsi), %mm3
	movntq	%mm0, 224(%rdi)
	movntq	%mm1, 232(%rdi)
	movntq	%mm2, 240(%rdi)
	movntq	%mm3, 248(%rdi)
	movq	256(%rbp), %mm0
	movq	264(%rbp), %mm1
	movq	272(%rbp), %mm2
	movq	280(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	256(%rsi), %mm0
	paddusw	264(%rsi), %mm1
	paddusw	272(%rsi), %mm2
	paddusw	280(%rsi), %mm3
	movntq	%mm0, 256(%rdi)
	movntq	%mm1, 264(%rdi)
	movntq	%mm2, 272(%rdi)
	movntq	%mm3, 280(%rdi)
	movq	288(%rbp), %mm0
	movq	296(%rbp), %mm1
	movq	304(%rbp), %mm2
	movq	312(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	288(%rsi), %mm0
	paddusw	296(%rsi), %mm1
	paddusw	304(%rsi), %mm2
	paddusw	312(%rsi), %mm3
	movntq	%mm0, 288(%rdi)
	movntq	%mm1, 296(%rdi)
	movntq	%mm2, 304(%rdi)
	movntq	%mm3, 312(%rdi)
	movq	320(%rbp), %mm0
	movq	328(%rbp), %mm1
	movq	336(%rbp), %mm2
	movq	344(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	320(%rsi), %mm0
	paddusw	328(%rsi), %mm1
	paddusw	336(%rsi), %mm2
	paddusw	344(%rsi), %mm3
	movntq	%mm0, 320(%rdi)
	movntq	%mm1, 328(%rdi)
	movntq	%mm2, 336(%rdi)
	movntq	%mm3, 344(%rdi)
	movq	352(%rbp), %mm0
	movq	360(%rbp), %mm1
	movq	368(%rbp), %mm2
	movq	376(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	352(%rsi), %mm0
	paddusw	360(%rsi), %mm1
	paddusw	368(%rsi), %mm2
	paddusw	376(%rsi), %mm3
	movntq	%mm0, 352(%rdi)
	movntq	%mm1, 360(%rdi)
	movntq	%mm2, 368(%rdi)
	movntq	%mm3, 376(%rdi)
	movq	384(%rbp), %mm0
	movq	392(%rbp), %mm1
	movq	400(%rbp), %mm2
	movq	408(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	384(%rsi), %mm0
	paddusw	392(%rsi), %mm1
	paddusw	400(%rsi), %mm2
	paddusw	408(%rsi), %mm3
	movntq	%mm0, 384(%rdi)
	movntq	%mm1, 392(%rdi)
	movntq	%mm2, 400(%rdi)
	movntq	%mm3, 408(%rdi)
	movq	416(%rbp), %mm0
	movq	424(%rbp), %mm1
	movq	432(%rbp), %mm2
	movq	440(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	416(%rsi), %mm0
	paddusw	424(%rsi), %mm1
	paddusw	432(%rsi), %mm2
	paddusw	440(%rsi), %mm3
	movntq	%mm0, 416(%rdi)
	movntq	%mm1, 424(%rdi)
	movntq	%mm2, 432(%rdi)
	movntq	%mm3, 440(%rdi)
	movq	448(%rbp), %mm0
	movq	456(%rbp), %mm1
	movq	464(%rbp), %mm2
	movq	472(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	448(%rsi), %mm0
	paddusw	456(%rsi), %mm1
	paddusw	464(%rsi), %mm2
	paddusw	472(%rsi), %mm3
	movntq	%mm0, 448(%rdi)
	movntq	%mm1, 456(%rdi)
	movntq	%mm2, 464(%rdi)
	movntq	%mm3, 472(%rdi)
	movq	480(%rbp), %mm0
	movq	488(%rbp), %mm1
	movq	496(%rbp), %mm2
	movq	504(%rbp), %mm3
	pmullw	%mm4, %mm0
	pmullw	%mm4, %mm1
	pmullw	%mm4, %mm2
	pmullw	%mm4, %mm3
	paddusw	480(%rsi), %mm0
	paddusw	488(%rsi), %mm1
	paddusw	496(%rsi), %mm2
	paddusw	504(%rsi), %mm3
	movntq	%mm0, 480(%rdi)
	movntq	%mm1, 488(%rdi)
	movntq	%mm2, 496(%rdi)
	movntq	%mm3, 504(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	emms
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
