/*
**  SSEmark benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005-07 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl ssewr
ssewr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$512, %rax
	xorps	%xmm0, %xmm0
.mainwr:
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm0, 16(%rdi)
	movaps	%xmm0, 32(%rdi)
	movaps	%xmm0, 48(%rdi)
	movaps	%xmm0, 64(%rdi)
	movaps	%xmm0, 80(%rdi)
	movaps	%xmm0, 96(%rdi)
	movaps	%xmm0, 112(%rdi)
	movaps	%xmm0, 128(%rdi)
	movaps	%xmm0, 144(%rdi)
	movaps	%xmm0, 160(%rdi)
	movaps	%xmm0, 176(%rdi)
	movaps	%xmm0, 192(%rdi)
	movaps	%xmm0, 208(%rdi)
	movaps	%xmm0, 224(%rdi)
	movaps	%xmm0, 240(%rdi)
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm0, 272(%rdi)
	movaps	%xmm0, 288(%rdi)
	movaps	%xmm0, 304(%rdi)
	movaps	%xmm0, 320(%rdi)
	movaps	%xmm0, 336(%rdi)
	movaps	%xmm0, 352(%rdi)
	movaps	%xmm0, 368(%rdi)
	movaps	%xmm0, 384(%rdi)
	movaps	%xmm0, 400(%rdi)
	movaps	%xmm0, 416(%rdi)
	movaps	%xmm0, 432(%rdi)
	movaps	%xmm0, 448(%rdi)
	movaps	%xmm0, 464(%rdi)
	movaps	%xmm0, 480(%rdi)
	movaps	%xmm0, 496(%rdi)
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainwr

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl sserd
sserd:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$4, %rcx
	xorps	%xmm0, %xmm0
.prerd:
	movaps	%xmm0, 0(%rax)
	movaps	%xmm0, 16(%rax)
	movaps	%xmm0, 32(%rax)
	movaps	%xmm0, 48(%rax)
	addq	$64, %rax
	loopq	.prerd
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
.mainrd:
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainrd

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssewr_nt
ssewr_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rdi
	movq	$512, %rax
	xorps	%xmm0, %xmm0
.mainwr_nt:
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm0, 16(%rdi)
	movntps	%xmm0, 32(%rdi)
	movntps	%xmm0, 48(%rdi)
	movntps	%xmm0, 64(%rdi)
	movntps	%xmm0, 80(%rdi)
	movntps	%xmm0, 96(%rdi)
	movntps	%xmm0, 112(%rdi)
	movntps	%xmm0, 128(%rdi)
	movntps	%xmm0, 144(%rdi)
	movntps	%xmm0, 160(%rdi)
	movntps	%xmm0, 176(%rdi)
	movntps	%xmm0, 192(%rdi)
	movntps	%xmm0, 208(%rdi)
	movntps	%xmm0, 224(%rdi)
	movntps	%xmm0, 240(%rdi)
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm0, 272(%rdi)
	movntps	%xmm0, 288(%rdi)
	movntps	%xmm0, 304(%rdi)
	movntps	%xmm0, 320(%rdi)
	movntps	%xmm0, 336(%rdi)
	movntps	%xmm0, 352(%rdi)
	movntps	%xmm0, 368(%rdi)
	movntps	%xmm0, 384(%rdi)
	movntps	%xmm0, 400(%rdi)
	movntps	%xmm0, 416(%rdi)
	movntps	%xmm0, 432(%rdi)
	movntps	%xmm0, 448(%rdi)
	movntps	%xmm0, 464(%rdi)
	movntps	%xmm0, 480(%rdi)
	movntps	%xmm0, 496(%rdi)
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainwr_nt

	movq	%r12, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainwr_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl sserd_nt
sserd_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	subq	$32, %rsp
/* save the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
/* allocate */
	shlq	$10, %rdi
	call	malloc
	movq	%rax, %r12
/* prefill */
	movq	%rbx, %rcx
	shlq	$4, %rcx
	xorps	%xmm0, %xmm0
.prerd_nt:
	movntps	%xmm0, 0(%rax)
	movntps	%xmm0, 16(%rax)
	movntps	%xmm0, 32(%rax)
	movntps	%xmm0, 48(%rax)
	addq	$64, %rax
	loopq	.prerd_nt
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shlq	$1, %rbx
	decq	%rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	$512, %rax
.mainrd_nt:
/* every loop prefetches the next one */
	prefetchnta	512(%rsi)
	prefetchnta	576(%rsi)
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	prefetchnta	640(%rsi)
	prefetchnta	704(%rsi)
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	prefetchnta	768(%rsi)
	prefetchnta	832(%rsi)
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	prefetchnta	896(%rsi)
	prefetchnta	960(%rsi)
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15
	addq	%rax, %rsi
	decq	%rcx
	jnz	.mainrd_nt

/* the last loop of the memory block;
 * no more prefetches to avoid hidden page faults */
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15

	movq	%r12, %rsi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainrd_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
