/*
**  SSEmem benchmarks for RAMspeed (amd64)
**
**  (UNIX release)
**
**
**  This software is distributed under the terms of The Alasir Licence (TAL).
**  You should have received a copy of the licence together with the software.
**  If not, you should download it from http://www.alasir.com/licence/TAL.txt
**
**
**  Copyright (c) 2005-07 Paul V. Bolotoff <walter@alasir.com>
**
**  All rights reserved.
**
*/

.globl ssecp
ssecp:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.precp:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.precp
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.maincp:
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm1, 16(%rdi)
	movaps	%xmm2, 32(%rdi)
	movaps	%xmm3, 48(%rdi)
	movaps	%xmm4, 64(%rdi)
	movaps	%xmm5, 80(%rdi)
	movaps	%xmm6, 96(%rdi)
	movaps	%xmm7, 112(%rdi)
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movaps	%xmm8, 128(%rdi)
	movaps	%xmm9, 144(%rdi)
	movaps	%xmm10, 160(%rdi)
	movaps	%xmm11, 176(%rdi)
	movaps	%xmm12, 192(%rdi)
	movaps	%xmm13, 208(%rdi)
	movaps	%xmm14, 224(%rdi)
	movaps	%xmm15, 240(%rdi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm1, 272(%rdi)
	movaps	%xmm2, 288(%rdi)
	movaps	%xmm3, 304(%rdi)
	movaps	%xmm4, 320(%rdi)
	movaps	%xmm5, 336(%rdi)
	movaps	%xmm6, 352(%rdi)
	movaps	%xmm7, 368(%rdi)
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15
	movaps	%xmm8, 384(%rdi)
	movaps	%xmm9, 400(%rdi)
	movaps	%xmm10, 416(%rdi)
	movaps	%xmm11, 432(%rdi)
	movaps	%xmm12, 448(%rdi)
	movaps	%xmm13, 464(%rdi)
	movaps	%xmm14, 480(%rdi)
	movaps	%xmm15, 496(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssesc
ssesc:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.presc:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.presc
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$512, %rax
.mainsc:
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm1, 16(%rdi)
	movaps	%xmm2, 32(%rdi)
	movaps	%xmm3, 48(%rdi)
	movaps	%xmm4, 64(%rdi)
	movaps	%xmm5, 80(%rdi)
	movaps	%xmm6, 96(%rdi)
	movaps	%xmm7, 112(%rdi)
	movaps	128(%rsi), %xmm0
	movaps	144(%rsi), %xmm1
	movaps	160(%rsi), %xmm2
	movaps	176(%rsi), %xmm3
	movaps	192(%rsi), %xmm4
	movaps	208(%rsi), %xmm5
	movaps	224(%rsi), %xmm6
	movaps	240(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 128(%rdi)
	movaps	%xmm1, 144(%rdi)
	movaps	%xmm2, 160(%rdi)
	movaps	%xmm3, 176(%rdi)
	movaps	%xmm4, 192(%rdi)
	movaps	%xmm5, 208(%rdi)
	movaps	%xmm6, 224(%rdi)
	movaps	%xmm7, 240(%rdi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm1, 272(%rdi)
	movaps	%xmm2, 288(%rdi)
	movaps	%xmm3, 304(%rdi)
	movaps	%xmm4, 320(%rdi)
	movaps	%xmm5, 336(%rdi)
	movaps	%xmm6, 352(%rdi)
	movaps	%xmm7, 368(%rdi)
	movaps	384(%rsi), %xmm0
	movaps	400(%rsi), %xmm1
	movaps	416(%rsi), %xmm2
	movaps	432(%rsi), %xmm3
	movaps	448(%rsi), %xmm4
	movaps	464(%rsi), %xmm5
	movaps	480(%rsi), %xmm6
	movaps	496(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movaps	%xmm0, 384(%rdi)
	movaps	%xmm1, 400(%rdi)
	movaps	%xmm2, 416(%rdi)
	movaps	%xmm3, 432(%rdi)
	movaps	%xmm4, 448(%rdi)
	movaps	%xmm5, 464(%rdi)
	movaps	%xmm6, 480(%rdi)
	movaps	%xmm7, 496(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssead
ssead:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pread:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pread
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.mainad:
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm1, 16(%rdi)
	movaps	%xmm2, 32(%rdi)
	movaps	%xmm3, 48(%rdi)
	movaps	%xmm4, 64(%rdi)
	movaps	%xmm5, 80(%rdi)
	movaps	%xmm6, 96(%rdi)
	movaps	%xmm7, 112(%rdi)
	movaps	128(%rbp), %xmm8
	movaps	144(%rbp), %xmm9
	movaps	160(%rbp), %xmm10
	movaps	176(%rbp), %xmm11
	movaps	192(%rbp), %xmm12
	movaps	208(%rbp), %xmm13
	movaps	224(%rbp), %xmm14
	movaps	240(%rbp), %xmm15
	addps	128(%rsi), %xmm8
	addps	144(%rsi), %xmm9
	addps	160(%rsi), %xmm10
	addps	176(%rsi), %xmm11
	addps	192(%rsi), %xmm12
	addps	208(%rsi), %xmm13
	addps	224(%rsi), %xmm14
	addps	240(%rsi), %xmm15
	movaps	%xmm8, 128(%rdi)
	movaps	%xmm9, 144(%rdi)
	movaps	%xmm10, 160(%rdi)
	movaps	%xmm11, 176(%rdi)
	movaps	%xmm12, 192(%rdi)
	movaps	%xmm13, 208(%rdi)
	movaps	%xmm14, 224(%rdi)
	movaps	%xmm15, 240(%rdi)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm1, 272(%rdi)
	movaps	%xmm2, 288(%rdi)
	movaps	%xmm3, 304(%rdi)
	movaps	%xmm4, 320(%rdi)
	movaps	%xmm5, 336(%rdi)
	movaps	%xmm6, 352(%rdi)
	movaps	%xmm7, 368(%rdi)
	movaps	384(%rbp), %xmm8
	movaps	400(%rbp), %xmm9
	movaps	416(%rbp), %xmm10
	movaps	432(%rbp), %xmm11
	movaps	448(%rbp), %xmm12
	movaps	464(%rbp), %xmm13
	movaps	480(%rbp), %xmm14
	movaps	496(%rbp), %xmm15
	addps	384(%rsi), %xmm8
	addps	400(%rsi), %xmm9
	addps	416(%rsi), %xmm10
	addps	432(%rsi), %xmm11
	addps	448(%rsi), %xmm12
	addps	464(%rsi), %xmm13
	addps	480(%rsi), %xmm14
	addps	496(%rsi), %xmm15
	movaps	%xmm8, 384(%rdi)
	movaps	%xmm9, 400(%rdi)
	movaps	%xmm10, 416(%rdi)
	movaps	%xmm11, 432(%rdi)
	movaps	%xmm12, 448(%rdi)
	movaps	%xmm13, 464(%rdi)
	movaps	%xmm14, 480(%rdi)
	movaps	%xmm15, 496(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssetr
ssetr:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pretr:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pretr
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$9, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$512, %rax
.maintr:
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movaps	%xmm0, 0(%rdi)
	movaps	%xmm1, 16(%rdi)
	movaps	%xmm2, 32(%rdi)
	movaps	%xmm3, 48(%rdi)
	movaps	%xmm4, 64(%rdi)
	movaps	%xmm5, 80(%rdi)
	movaps	%xmm6, 96(%rdi)
	movaps	%xmm7, 112(%rdi)
	movaps	128(%rbp), %xmm0
	movaps	144(%rbp), %xmm1
	movaps	160(%rbp), %xmm2
	movaps	176(%rbp), %xmm3
	movaps	192(%rbp), %xmm4
	movaps	208(%rbp), %xmm5
	movaps	224(%rbp), %xmm6
	movaps	240(%rbp), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	128(%rsi), %xmm0
	addps	144(%rsi), %xmm1
	addps	160(%rsi), %xmm2
	addps	176(%rsi), %xmm3
	addps	192(%rsi), %xmm4
	addps	208(%rsi), %xmm5
	addps	224(%rsi), %xmm6
	addps	240(%rsi), %xmm7
	movaps	%xmm0, 128(%rdi)
	movaps	%xmm1, 144(%rdi)
	movaps	%xmm2, 160(%rdi)
	movaps	%xmm3, 176(%rdi)
	movaps	%xmm4, 192(%rdi)
	movaps	%xmm5, 208(%rdi)
	movaps	%xmm6, 224(%rdi)
	movaps	%xmm7, 240(%rdi)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movaps	%xmm0, 256(%rdi)
	movaps	%xmm1, 272(%rdi)
	movaps	%xmm2, 288(%rdi)
	movaps	%xmm3, 304(%rdi)
	movaps	%xmm4, 320(%rdi)
	movaps	%xmm5, 336(%rdi)
	movaps	%xmm6, 352(%rdi)
	movaps	%xmm7, 368(%rdi)
	movaps	384(%rbp), %xmm0
	movaps	400(%rbp), %xmm1
	movaps	416(%rbp), %xmm2
	movaps	432(%rbp), %xmm3
	movaps	448(%rbp), %xmm4
	movaps	464(%rbp), %xmm5
	movaps	480(%rbp), %xmm6
	movaps	496(%rbp), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	384(%rsi), %xmm0
	addps	400(%rsi), %xmm1
	addps	416(%rsi), %xmm2
	addps	432(%rsi), %xmm3
	addps	448(%rsi), %xmm4
	addps	464(%rsi), %xmm5
	addps	480(%rsi), %xmm6
	addps	496(%rsi), %xmm7
	movaps	%xmm0, 384(%rdi)
	movaps	%xmm1, 400(%rdi)
	movaps	%xmm2, 416(%rdi)
	movaps	%xmm3, 432(%rdi)
	movaps	%xmm4, 448(%rdi)
	movaps	%xmm5, 464(%rdi)
	movaps	%xmm6, 480(%rdi)
	movaps	%xmm7, 496(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssecp_nt
ssecp_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.precp_nt:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.precp_nt
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$1024, %rax
.maincp_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	1024(%rsi)
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	prefetchnta	1088(%rsi)
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	prefetchnta	1152(%rsi)
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	prefetchnta	1216(%rsi)
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetchnta	1280(%rsi)
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	prefetchnta	1344(%rsi)
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	prefetchnta	1408(%rsi)
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	prefetchnta	1472(%rsi)
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movntps	%xmm8, 128(%rdi)
	movntps	%xmm9, 144(%rdi)
	movntps	%xmm10, 160(%rdi)
	movntps	%xmm11, 176(%rdi)
	movntps	%xmm12, 192(%rdi)
	movntps	%xmm13, 208(%rdi)
	movntps	%xmm14, 224(%rdi)
	movntps	%xmm15, 240(%rdi)
	prefetchnta	1536(%rsi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	prefetchnta	1600(%rsi)
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	prefetchnta	1664(%rsi)
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	prefetchnta	1728(%rsi)
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetchnta	1792(%rsi)
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	prefetchnta	1856(%rsi)
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	prefetchnta	1920(%rsi)
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	prefetchnta	1984(%rsi)
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15
	movntps	%xmm8, 384(%rdi)
	movntps	%xmm9, 400(%rdi)
	movntps	%xmm10, 416(%rdi)
	movntps	%xmm11, 432(%rdi)
	movntps	%xmm12, 448(%rdi)
	movntps	%xmm13, 464(%rdi)
	movntps	%xmm14, 480(%rdi)
	movntps	%xmm15, 496(%rdi)
	movaps	512(%rsi), %xmm0
	movaps	528(%rsi), %xmm1
	movaps	544(%rsi), %xmm2
	movaps	560(%rsi), %xmm3
	movaps	576(%rsi), %xmm4
	movaps	592(%rsi), %xmm5
	movaps	608(%rsi), %xmm6
	movaps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	movaps	640(%rsi), %xmm0
	movaps	656(%rsi), %xmm1
	movaps	672(%rsi), %xmm2
	movaps	688(%rsi), %xmm3
	movaps	704(%rsi), %xmm4
	movaps	720(%rsi), %xmm5
	movaps	736(%rsi), %xmm6
	movaps	752(%rsi), %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	movaps	768(%rsi), %xmm0
	movaps	784(%rsi), %xmm1
	movaps	800(%rsi), %xmm2
	movaps	816(%rsi), %xmm3
	movaps	832(%rsi), %xmm4
	movaps	848(%rsi), %xmm5
	movaps	864(%rsi), %xmm6
	movaps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	movaps	896(%rsi), %xmm0
	movaps	912(%rsi), %xmm1
	movaps	928(%rsi), %xmm2
	movaps	944(%rsi), %xmm3
	movaps	960(%rsi), %xmm4
	movaps	976(%rsi), %xmm5
	movaps	992(%rsi), %xmm6
	movaps	1008(%rsi), %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp_nt

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssesc_nt
ssesc_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.presc_nt:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.presc_nt
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$1024, %rax
.mainsc_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	1024(%rsi)
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	prefetchnta	1088(%rsi)
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	prefetchnta	1152(%rsi)
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	prefetchnta	1216(%rsi)
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetchnta	1280(%rsi)
	movaps	128(%rsi), %xmm0
	movaps	144(%rsi), %xmm1
	prefetchnta	1344(%rsi)
	movaps	160(%rsi), %xmm2
	movaps	176(%rsi), %xmm3
	prefetchnta	1408(%rsi)
	movaps	192(%rsi), %xmm4
	movaps	208(%rsi), %xmm5
	prefetchnta	1472(%rsi)
	movaps	224(%rsi), %xmm6
	movaps	240(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 128(%rdi)
	movntps	%xmm1, 144(%rdi)
	movntps	%xmm2, 160(%rdi)
	movntps	%xmm3, 176(%rdi)
	movntps	%xmm4, 192(%rdi)
	movntps	%xmm5, 208(%rdi)
	movntps	%xmm6, 224(%rdi)
	movntps	%xmm7, 240(%rdi)
	prefetchnta	1536(%rsi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	prefetchnta	1600(%rsi)
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	prefetchnta	1664(%rsi)
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	prefetchnta	1728(%rsi)
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetchnta	1792(%rsi)
	movaps	384(%rsi), %xmm0
	movaps	400(%rsi), %xmm1
	prefetchnta	1856(%rsi)
	movaps	416(%rsi), %xmm2
	movaps	432(%rsi), %xmm3
	prefetchnta	1920(%rsi)
	movaps	448(%rsi), %xmm4
	movaps	464(%rsi), %xmm5
	prefetchnta	1984(%rsi)
	movaps	480(%rsi), %xmm6
	movaps	496(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 384(%rdi)
	movntps	%xmm1, 400(%rdi)
	movntps	%xmm2, 416(%rdi)
	movntps	%xmm3, 432(%rdi)
	movntps	%xmm4, 448(%rdi)
	movntps	%xmm5, 464(%rdi)
	movntps	%xmm6, 480(%rdi)
	movntps	%xmm7, 496(%rdi)
	movaps	512(%rsi), %xmm0
	movaps	528(%rsi), %xmm1
	movaps	544(%rsi), %xmm2
	movaps	560(%rsi), %xmm3
	movaps	576(%rsi), %xmm4
	movaps	592(%rsi), %xmm5
	movaps	608(%rsi), %xmm6
	movaps	624(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	movaps	640(%rsi), %xmm0
	movaps	656(%rsi), %xmm1
	movaps	672(%rsi), %xmm2
	movaps	688(%rsi), %xmm3
	movaps	704(%rsi), %xmm4
	movaps	720(%rsi), %xmm5
	movaps	736(%rsi), %xmm6
	movaps	752(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	movaps	768(%rsi), %xmm0
	movaps	784(%rsi), %xmm1
	movaps	800(%rsi), %xmm2
	movaps	816(%rsi), %xmm3
	movaps	832(%rsi), %xmm4
	movaps	848(%rsi), %xmm5
	movaps	864(%rsi), %xmm6
	movaps	880(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	movaps	896(%rsi), %xmm0
	movaps	912(%rsi), %xmm1
	movaps	928(%rsi), %xmm2
	movaps	944(%rsi), %xmm3
	movaps	960(%rsi), %xmm4
	movaps	976(%rsi), %xmm5
	movaps	992(%rsi), %xmm6
	movaps	1008(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc_nt

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssead_nt
ssead_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pread_nt:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pread_nt
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$1024, %rax
.mainad_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	1024(%rbp)
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	prefetchnta	1024(%rsi)
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	prefetchnta	1088(%rbp)
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	prefetchnta	1088(%rsi)
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetchnta	1152(%rbp)
	movaps	128(%rbp), %xmm8
	movaps	144(%rbp), %xmm9
	movaps	160(%rbp), %xmm10
	movaps	176(%rbp), %xmm11
	prefetchnta	1152(%rsi)
	movaps	192(%rbp), %xmm12
	movaps	208(%rbp), %xmm13
	movaps	224(%rbp), %xmm14
	movaps	240(%rbp), %xmm15
	prefetchnta	1216(%rbp)
	addps	128(%rsi), %xmm8
	addps	144(%rsi), %xmm9
	addps	160(%rsi), %xmm10
	addps	176(%rsi), %xmm11
	prefetchnta	1216(%rsi)
	addps	192(%rsi), %xmm12
	addps	208(%rsi), %xmm13
	addps	224(%rsi), %xmm14
	addps	240(%rsi), %xmm15
	movntps	%xmm8, 128(%rdi)
	movntps	%xmm9, 144(%rdi)
	movntps	%xmm10, 160(%rdi)
	movntps	%xmm11, 176(%rdi)
	movntps	%xmm12, 192(%rdi)
	movntps	%xmm13, 208(%rdi)
	movntps	%xmm14, 224(%rdi)
	movntps	%xmm15, 240(%rdi)
	prefetchnta	1280(%rbp)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	prefetchnta	1280(%rsi)
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	prefetchnta	1344(%rbp)
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	prefetchnta	1344(%rsi)
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetchnta	1408(%rbp)
	movaps	384(%rbp), %xmm8
	movaps	400(%rbp), %xmm9
	movaps	416(%rbp), %xmm10
	movaps	432(%rbp), %xmm11
	prefetchnta	1408(%rsi)
	movaps	448(%rbp), %xmm12
	movaps	464(%rbp), %xmm13
	movaps	480(%rbp), %xmm14
	movaps	496(%rbp), %xmm15
	prefetchnta	1472(%rbp)
	addps	384(%rsi), %xmm8
	addps	400(%rsi), %xmm9
	addps	416(%rsi), %xmm10
	addps	432(%rsi), %xmm11
	prefetchnta	1472(%rsi)
	addps	448(%rsi), %xmm12
	addps	464(%rsi), %xmm13
	addps	480(%rsi), %xmm14
	addps	496(%rsi), %xmm15
	movntps	%xmm8, 384(%rdi)
	movntps	%xmm9, 400(%rdi)
	movntps	%xmm10, 416(%rdi)
	movntps	%xmm11, 432(%rdi)
	movntps	%xmm12, 448(%rdi)
	movntps	%xmm13, 464(%rdi)
	movntps	%xmm14, 480(%rdi)
	movntps	%xmm15, 496(%rdi)
	prefetchnta	1536(%rbp)
	movaps	512(%rbp), %xmm0
	movaps	528(%rbp), %xmm1
	movaps	544(%rbp), %xmm2
	movaps	560(%rbp), %xmm3
	prefetchnta	1536(%rsi)
	movaps	576(%rbp), %xmm4
	movaps	592(%rbp), %xmm5
	movaps	608(%rbp), %xmm6
	movaps	624(%rbp), %xmm7
	prefetchnta	1600(%rsi)
	addps	512(%rsi), %xmm0
	addps	528(%rsi), %xmm1
	addps	544(%rsi), %xmm2
	addps	560(%rsi), %xmm3
	prefetchnta	1600(%rbp)
	addps	576(%rsi), %xmm4
	addps	592(%rsi), %xmm5
	addps	608(%rsi), %xmm6
	addps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	prefetchnta	1664(%rbp)
	movaps	640(%rbp), %xmm8
	movaps	656(%rbp), %xmm9
	movaps	672(%rbp), %xmm10
	movaps	688(%rbp), %xmm11
	prefetchnta	1664(%rsi)
	movaps	704(%rbp), %xmm12
	movaps	720(%rbp), %xmm13
	movaps	736(%rbp), %xmm14
	movaps	752(%rbp), %xmm15
	prefetchnta	1728(%rbp)
	addps	640(%rsi), %xmm8
	addps	656(%rsi), %xmm9
	addps	672(%rsi), %xmm10
	addps	688(%rsi), %xmm11
	prefetchnta	1728(%rsi)
	addps	704(%rsi), %xmm12
	addps	720(%rsi), %xmm13
	addps	736(%rsi), %xmm14
	addps	752(%rsi), %xmm15
	movntps	%xmm8, 640(%rdi)
	movntps	%xmm9, 656(%rdi)
	movntps	%xmm10, 672(%rdi)
	movntps	%xmm11, 688(%rdi)
	movntps	%xmm12, 704(%rdi)
	movntps	%xmm13, 720(%rdi)
	movntps	%xmm14, 736(%rdi)
	movntps	%xmm15, 752(%rdi)
	prefetchnta	1792(%rbp)
	movaps	768(%rbp), %xmm0
	movaps	784(%rbp), %xmm1
	movaps	800(%rbp), %xmm2
	movaps	816(%rbp), %xmm3
	prefetchnta	1792(%rsi)
	movaps	832(%rbp), %xmm4
	movaps	848(%rbp), %xmm5
	movaps	864(%rbp), %xmm6
	movaps	880(%rbp), %xmm7
	prefetchnta	1856(%rbp)
	addps	768(%rsi), %xmm0
	addps	784(%rsi), %xmm1
	addps	800(%rsi), %xmm2
	addps	816(%rsi), %xmm3
	prefetchnta	1856(%rsi)
	addps	832(%rsi), %xmm4
	addps	848(%rsi), %xmm5
	addps	864(%rsi), %xmm6
	addps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	prefetchnta	1920(%rbp)
	movaps	896(%rbp), %xmm8
	movaps	912(%rbp), %xmm9
	movaps	928(%rbp), %xmm10
	movaps	944(%rbp), %xmm11
	prefetchnta	1920(%rsi)
	movaps	960(%rbp), %xmm12
	movaps	976(%rbp), %xmm13
	movaps	992(%rbp), %xmm14
	movaps	1008(%rbp), %xmm15
	prefetchnta	1984(%rbp)
	addps	896(%rsi), %xmm8
	addps	912(%rsi), %xmm9
	addps	928(%rsi), %xmm10
	addps	944(%rsi), %xmm11
	prefetchnta	1984(%rsi)
	addps	960(%rsi), %xmm12
	addps	976(%rsi), %xmm13
	addps	992(%rsi), %xmm14
	addps	1008(%rsi), %xmm15
	movntps	%xmm8, 896(%rdi)
	movntps	%xmm9, 912(%rdi)
	movntps	%xmm10, 928(%rdi)
	movntps	%xmm11, 944(%rdi)
	movntps	%xmm12, 960(%rdi)
	movntps	%xmm13, 976(%rdi)
	movntps	%xmm14, 992(%rdi)
	movntps	%xmm15, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad_nt

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssetr_nt
ssetr_nt:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pretr_nt:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pretr_nt
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$1024, %rax
.maintr_nt:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetchnta	1024(%rbp)
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	prefetchnta	1024(%rsi)
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	prefetchnta	1088(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1088(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetchnta	1152(%rbp)
	movaps	128(%rbp), %xmm0
	movaps	144(%rbp), %xmm1
	movaps	160(%rbp), %xmm2
	movaps	176(%rbp), %xmm3
	prefetchnta	1152(%rsi)
	movaps	192(%rbp), %xmm4
	movaps	208(%rbp), %xmm5
	movaps	224(%rbp), %xmm6
	movaps	240(%rbp), %xmm7
	prefetchnta	1216(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1216(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	128(%rsi), %xmm0
	addps	144(%rsi), %xmm1
	addps	160(%rsi), %xmm2
	addps	176(%rsi), %xmm3
	addps	192(%rsi), %xmm4
	addps	208(%rsi), %xmm5
	addps	224(%rsi), %xmm6
	addps	240(%rsi), %xmm7
	movntps	%xmm0, 128(%rdi)
	movntps	%xmm1, 144(%rdi)
	movntps	%xmm2, 160(%rdi)
	movntps	%xmm3, 176(%rdi)
	movntps	%xmm4, 192(%rdi)
	movntps	%xmm5, 208(%rdi)
	movntps	%xmm6, 224(%rdi)
	movntps	%xmm7, 240(%rdi)
	prefetchnta	1280(%rbp)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	prefetchnta	1280(%rsi)
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	prefetchnta	1344(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1344(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetchnta	1408(%rbp)
	movaps	384(%rbp), %xmm0
	movaps	400(%rbp), %xmm1
	movaps	416(%rbp), %xmm2
	movaps	432(%rbp), %xmm3
	prefetchnta	1408(%rsi)
	movaps	448(%rbp), %xmm4
	movaps	464(%rbp), %xmm5
	movaps	480(%rbp), %xmm6
	movaps	496(%rbp), %xmm7
	prefetchnta	1472(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1472(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	384(%rsi), %xmm0
	addps	400(%rsi), %xmm1
	addps	416(%rsi), %xmm2
	addps	432(%rsi), %xmm3
	addps	448(%rsi), %xmm4
	addps	464(%rsi), %xmm5
	addps	480(%rsi), %xmm6
	addps	496(%rsi), %xmm7
	movntps	%xmm0, 384(%rdi)
	movntps	%xmm1, 400(%rdi)
	movntps	%xmm2, 416(%rdi)
	movntps	%xmm3, 432(%rdi)
	movntps	%xmm4, 448(%rdi)
	movntps	%xmm5, 464(%rdi)
	movntps	%xmm6, 480(%rdi)
	movntps	%xmm7, 496(%rdi)
	prefetchnta	1536(%rbp)
	movaps	512(%rbp), %xmm0
	movaps	528(%rbp), %xmm1
	movaps	544(%rbp), %xmm2
	movaps	560(%rbp), %xmm3
	prefetchnta	1536(%rsi)
	movaps	576(%rbp), %xmm4
	movaps	592(%rbp), %xmm5
	movaps	608(%rbp), %xmm6
	movaps	624(%rbp), %xmm7
	prefetchnta	1600(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1600(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	512(%rsi), %xmm0
	addps	528(%rsi), %xmm1
	addps	544(%rsi), %xmm2
	addps	560(%rsi), %xmm3
	addps	576(%rsi), %xmm4
	addps	592(%rsi), %xmm5
	addps	608(%rsi), %xmm6
	addps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	prefetchnta	1664(%rbp)
	movaps	640(%rbp), %xmm0
	movaps	656(%rbp), %xmm1
	movaps	672(%rbp), %xmm2
	movaps	688(%rbp), %xmm3
	prefetchnta	1664(%rsi)
	movaps	704(%rbp), %xmm4
	movaps	720(%rbp), %xmm5
	movaps	736(%rbp), %xmm6
	movaps	752(%rbp), %xmm7
	prefetchnta	1728(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1728(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	640(%rsi), %xmm0
	addps	656(%rsi), %xmm1
	addps	672(%rsi), %xmm2
	addps	688(%rsi), %xmm3
	addps	704(%rsi), %xmm4
	addps	720(%rsi), %xmm5
	addps	736(%rsi), %xmm6
	addps	752(%rsi), %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	prefetchnta	1792(%rbp)
	movaps	768(%rbp), %xmm0
	movaps	784(%rbp), %xmm1
	movaps	800(%rbp), %xmm2
	movaps	816(%rbp), %xmm3
	prefetchnta	1792(%rsi)
	movaps	832(%rbp), %xmm4
	movaps	848(%rbp), %xmm5
	movaps	864(%rbp), %xmm6
	movaps	880(%rbp), %xmm7
	prefetchnta	1856(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1856(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	768(%rsi), %xmm0
	addps	784(%rsi), %xmm1
	addps	800(%rsi), %xmm2
	addps	816(%rsi), %xmm3
	addps	832(%rsi), %xmm4
	addps	848(%rsi), %xmm5
	addps	864(%rsi), %xmm6
	addps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	prefetchnta	1920(%rbp)
	movaps	896(%rbp), %xmm0
	movaps	912(%rbp), %xmm1
	movaps	928(%rbp), %xmm2
	movaps	944(%rbp), %xmm3
	prefetchnta	1920(%rsi)
	movaps	960(%rbp), %xmm4
	movaps	976(%rbp), %xmm5
	movaps	992(%rbp), %xmm6
	movaps	1008(%rbp), %xmm7
	prefetchnta	1984(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetchnta	1984(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	896(%rsi), %xmm0
	addps	912(%rsi), %xmm1
	addps	928(%rsi), %xmm2
	addps	944(%rsi), %xmm3
	addps	960(%rsi), %xmm4
	addps	976(%rsi), %xmm5
	addps	992(%rsi), %xmm6
	addps	1008(%rsi), %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr_nt

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr_nt

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssecp_nt_t0
ssecp_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.precp_nt_t0:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.precp_nt_t0
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$1024, %rax
.maincp_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	1024(%rsi)
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	prefetcht0	1088(%rsi)
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	prefetcht0	1152(%rsi)
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	prefetcht0	1216(%rsi)
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetcht0	1280(%rsi)
	movaps	128(%rsi), %xmm8
	movaps	144(%rsi), %xmm9
	prefetcht0	1344(%rsi)
	movaps	160(%rsi), %xmm10
	movaps	176(%rsi), %xmm11
	prefetcht0	1408(%rsi)
	movaps	192(%rsi), %xmm12
	movaps	208(%rsi), %xmm13
	prefetcht0	1472(%rsi)
	movaps	224(%rsi), %xmm14
	movaps	240(%rsi), %xmm15
	movntps	%xmm8, 128(%rdi)
	movntps	%xmm9, 144(%rdi)
	movntps	%xmm10, 160(%rdi)
	movntps	%xmm11, 176(%rdi)
	movntps	%xmm12, 192(%rdi)
	movntps	%xmm13, 208(%rdi)
	movntps	%xmm14, 224(%rdi)
	movntps	%xmm15, 240(%rdi)
	prefetcht0	1536(%rsi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	prefetcht0	1600(%rsi)
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	prefetcht0	1664(%rsi)
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	prefetcht0	1728(%rsi)
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetcht0	1792(%rsi)
	movaps	384(%rsi), %xmm8
	movaps	400(%rsi), %xmm9
	prefetcht0	1856(%rsi)
	movaps	416(%rsi), %xmm10
	movaps	432(%rsi), %xmm11
	prefetcht0	1920(%rsi)
	movaps	448(%rsi), %xmm12
	movaps	464(%rsi), %xmm13
	prefetcht0	1984(%rsi)
	movaps	480(%rsi), %xmm14
	movaps	496(%rsi), %xmm15
	movntps	%xmm8, 384(%rdi)
	movntps	%xmm9, 400(%rdi)
	movntps	%xmm10, 416(%rdi)
	movntps	%xmm11, 432(%rdi)
	movntps	%xmm12, 448(%rdi)
	movntps	%xmm13, 464(%rdi)
	movntps	%xmm14, 480(%rdi)
	movntps	%xmm15, 496(%rdi)
	movaps	512(%rsi), %xmm0
	movaps	528(%rsi), %xmm1
	movaps	544(%rsi), %xmm2
	movaps	560(%rsi), %xmm3
	movaps	576(%rsi), %xmm4
	movaps	592(%rsi), %xmm5
	movaps	608(%rsi), %xmm6
	movaps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	movaps	640(%rsi), %xmm0
	movaps	656(%rsi), %xmm1
	movaps	672(%rsi), %xmm2
	movaps	688(%rsi), %xmm3
	movaps	704(%rsi), %xmm4
	movaps	720(%rsi), %xmm5
	movaps	736(%rsi), %xmm6
	movaps	752(%rsi), %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	movaps	768(%rsi), %xmm0
	movaps	784(%rsi), %xmm1
	movaps	800(%rsi), %xmm2
	movaps	816(%rsi), %xmm3
	movaps	832(%rsi), %xmm4
	movaps	848(%rsi), %xmm5
	movaps	864(%rsi), %xmm6
	movaps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	movaps	896(%rsi), %xmm0
	movaps	912(%rsi), %xmm1
	movaps	928(%rsi), %xmm2
	movaps	944(%rsi), %xmm3
	movaps	960(%rsi), %xmm4
	movaps	976(%rsi), %xmm5
	movaps	992(%rsi), %xmm6
	movaps	1008(%rsi), %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maincp_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.maincp_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssesc_nt_t0
ssesc_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %rbp
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	finit
	fldpi
.presc_nt_t0:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	addq	$16, %rsi
	loopq	.presc_nt_t0
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	$1024, %rax
.mainsc_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	1024(%rsi)
	movaps	0(%rsi), %xmm0
	movaps	16(%rsi), %xmm1
	prefetcht0	1088(%rsi)
	movaps	32(%rsi), %xmm2
	movaps	48(%rsi), %xmm3
	prefetcht0	1152(%rsi)
	movaps	64(%rsi), %xmm4
	movaps	80(%rsi), %xmm5
	prefetcht0	1216(%rsi)
	movaps	96(%rsi), %xmm6
	movaps	112(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetcht0	1280(%rsi)
	movaps	128(%rsi), %xmm0
	movaps	144(%rsi), %xmm1
	prefetcht0	1344(%rsi)
	movaps	160(%rsi), %xmm2
	movaps	176(%rsi), %xmm3
	prefetcht0	1408(%rsi)
	movaps	192(%rsi), %xmm4
	movaps	208(%rsi), %xmm5
	prefetcht0	1472(%rsi)
	movaps	224(%rsi), %xmm6
	movaps	240(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 128(%rdi)
	movntps	%xmm1, 144(%rdi)
	movntps	%xmm2, 160(%rdi)
	movntps	%xmm3, 176(%rdi)
	movntps	%xmm4, 192(%rdi)
	movntps	%xmm5, 208(%rdi)
	movntps	%xmm6, 224(%rdi)
	movntps	%xmm7, 240(%rdi)
	prefetcht0	1536(%rsi)
	movaps	256(%rsi), %xmm0
	movaps	272(%rsi), %xmm1
	prefetcht0	1600(%rsi)
	movaps	288(%rsi), %xmm2
	movaps	304(%rsi), %xmm3
	prefetcht0	1664(%rsi)
	movaps	320(%rsi), %xmm4
	movaps	336(%rsi), %xmm5
	prefetcht0	1728(%rsi)
	movaps	352(%rsi), %xmm6
	movaps	368(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetcht0	1792(%rsi)
	movaps	384(%rsi), %xmm0
	movaps	400(%rsi), %xmm1
	prefetcht0	1856(%rsi)
	movaps	416(%rsi), %xmm2
	movaps	432(%rsi), %xmm3
	prefetcht0	1920(%rsi)
	movaps	448(%rsi), %xmm4
	movaps	464(%rsi), %xmm5
	prefetcht0	1984(%rsi)
	movaps	480(%rsi), %xmm6
	movaps	496(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 384(%rdi)
	movntps	%xmm1, 400(%rdi)
	movntps	%xmm2, 416(%rdi)
	movntps	%xmm3, 432(%rdi)
	movntps	%xmm4, 448(%rdi)
	movntps	%xmm5, 464(%rdi)
	movntps	%xmm6, 480(%rdi)
	movntps	%xmm7, 496(%rdi)
	movaps	512(%rsi), %xmm0
	movaps	528(%rsi), %xmm1
	movaps	544(%rsi), %xmm2
	movaps	560(%rsi), %xmm3
	movaps	576(%rsi), %xmm4
	movaps	592(%rsi), %xmm5
	movaps	608(%rsi), %xmm6
	movaps	624(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	movaps	640(%rsi), %xmm0
	movaps	656(%rsi), %xmm1
	movaps	672(%rsi), %xmm2
	movaps	688(%rsi), %xmm3
	movaps	704(%rsi), %xmm4
	movaps	720(%rsi), %xmm5
	movaps	736(%rsi), %xmm6
	movaps	752(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	movaps	768(%rsi), %xmm0
	movaps	784(%rsi), %xmm1
	movaps	800(%rsi), %xmm2
	movaps	816(%rsi), %xmm3
	movaps	832(%rsi), %xmm4
	movaps	848(%rsi), %xmm5
	movaps	864(%rsi), %xmm6
	movaps	880(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	movaps	896(%rsi), %xmm0
	movaps	912(%rsi), %xmm1
	movaps	928(%rsi), %xmm2
	movaps	944(%rsi), %xmm3
	movaps	960(%rsi), %xmm4
	movaps	976(%rsi), %xmm5
	movaps	992(%rsi), %xmm6
	movaps	1008(%rsi), %xmm7
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainsc_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rdi
	movq	%rbx, %rcx
	decq	%rbp
	jnz	.mainsc_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssead_nt_t0
ssead_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pread_nt_t0:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pread_nt_t0
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$1024, %rax
.mainad_nt_t0:
/* every loop prefetches the next one;
 * don't care about hidden page faults of the last loop */
	prefetcht0	1024(%rbp)
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	prefetcht0	1024(%rsi)
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	prefetcht0	1088(%rbp)
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	prefetcht0	1088(%rsi)
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetcht0	1152(%rbp)
	movaps	128(%rbp), %xmm8
	movaps	144(%rbp), %xmm9
	movaps	160(%rbp), %xmm10
	movaps	176(%rbp), %xmm11
	prefetcht0	1152(%rsi)
	movaps	192(%rbp), %xmm12
	movaps	208(%rbp), %xmm13
	movaps	224(%rbp), %xmm14
	movaps	240(%rbp), %xmm15
	prefetcht0	1216(%rbp)
	addps	128(%rsi), %xmm8
	addps	144(%rsi), %xmm9
	addps	160(%rsi), %xmm10
	addps	176(%rsi), %xmm11
	prefetcht0	1216(%rsi)
	addps	192(%rsi), %xmm12
	addps	208(%rsi), %xmm13
	addps	224(%rsi), %xmm14
	addps	240(%rsi), %xmm15
	movntps	%xmm8, 128(%rdi)
	movntps	%xmm9, 144(%rdi)
	movntps	%xmm10, 160(%rdi)
	movntps	%xmm11, 176(%rdi)
	movntps	%xmm12, 192(%rdi)
	movntps	%xmm13, 208(%rdi)
	movntps	%xmm14, 224(%rdi)
	movntps	%xmm15, 240(%rdi)
	prefetcht0	1280(%rbp)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	prefetcht0	1280(%rsi)
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	prefetcht0	1344(%rbp)
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	prefetcht0	1344(%rsi)
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetcht0	1408(%rbp)
	movaps	384(%rbp), %xmm8
	movaps	400(%rbp), %xmm9
	movaps	416(%rbp), %xmm10
	movaps	432(%rbp), %xmm11
	prefetcht0	1408(%rsi)
	movaps	448(%rbp), %xmm12
	movaps	464(%rbp), %xmm13
	movaps	480(%rbp), %xmm14
	movaps	496(%rbp), %xmm15
	prefetcht0	1472(%rbp)
	addps	384(%rsi), %xmm8
	addps	400(%rsi), %xmm9
	addps	416(%rsi), %xmm10
	addps	432(%rsi), %xmm11
	prefetcht0	1472(%rsi)
	addps	448(%rsi), %xmm12
	addps	464(%rsi), %xmm13
	addps	480(%rsi), %xmm14
	addps	496(%rsi), %xmm15
	movntps	%xmm8, 384(%rdi)
	movntps	%xmm9, 400(%rdi)
	movntps	%xmm10, 416(%rdi)
	movntps	%xmm11, 432(%rdi)
	movntps	%xmm12, 448(%rdi)
	movntps	%xmm13, 464(%rdi)
	movntps	%xmm14, 480(%rdi)
	movntps	%xmm15, 496(%rdi)
	prefetcht0	1536(%rbp)
	movaps	512(%rbp), %xmm0
	movaps	528(%rbp), %xmm1
	movaps	544(%rbp), %xmm2
	movaps	560(%rbp), %xmm3
	prefetcht0	1536(%rsi)
	movaps	576(%rbp), %xmm4
	movaps	592(%rbp), %xmm5
	movaps	608(%rbp), %xmm6
	movaps	624(%rbp), %xmm7
	prefetcht0	1600(%rsi)
	addps	512(%rsi), %xmm0
	addps	528(%rsi), %xmm1
	addps	544(%rsi), %xmm2
	addps	560(%rsi), %xmm3
	prefetcht0	1600(%rbp)
	addps	576(%rsi), %xmm4
	addps	592(%rsi), %xmm5
	addps	608(%rsi), %xmm6
	addps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	prefetcht0	1664(%rbp)
	movaps	640(%rbp), %xmm8
	movaps	656(%rbp), %xmm9
	movaps	672(%rbp), %xmm10
	movaps	688(%rbp), %xmm11
	prefetcht0	1664(%rsi)
	movaps	704(%rbp), %xmm12
	movaps	720(%rbp), %xmm13
	movaps	736(%rbp), %xmm14
	movaps	752(%rbp), %xmm15
	prefetcht0	1728(%rbp)
	addps	640(%rsi), %xmm8
	addps	656(%rsi), %xmm9
	addps	672(%rsi), %xmm10
	addps	688(%rsi), %xmm11
	prefetcht0	1728(%rsi)
	addps	704(%rsi), %xmm12
	addps	720(%rsi), %xmm13
	addps	736(%rsi), %xmm14
	addps	752(%rsi), %xmm15
	movntps	%xmm8, 640(%rdi)
	movntps	%xmm9, 656(%rdi)
	movntps	%xmm10, 672(%rdi)
	movntps	%xmm11, 688(%rdi)
	movntps	%xmm12, 704(%rdi)
	movntps	%xmm13, 720(%rdi)
	movntps	%xmm14, 736(%rdi)
	movntps	%xmm15, 752(%rdi)
	prefetcht0	1792(%rbp)
	movaps	768(%rbp), %xmm0
	movaps	784(%rbp), %xmm1
	movaps	800(%rbp), %xmm2
	movaps	816(%rbp), %xmm3
	prefetcht0	1792(%rsi)
	movaps	832(%rbp), %xmm4
	movaps	848(%rbp), %xmm5
	movaps	864(%rbp), %xmm6
	movaps	880(%rbp), %xmm7
	prefetcht0	1856(%rbp)
	addps	768(%rsi), %xmm0
	addps	784(%rsi), %xmm1
	addps	800(%rsi), %xmm2
	addps	816(%rsi), %xmm3
	prefetcht0	1856(%rsi)
	addps	832(%rsi), %xmm4
	addps	848(%rsi), %xmm5
	addps	864(%rsi), %xmm6
	addps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	prefetcht0	1920(%rbp)
	movaps	896(%rbp), %xmm8
	movaps	912(%rbp), %xmm9
	movaps	928(%rbp), %xmm10
	movaps	944(%rbp), %xmm11
	prefetcht0	1920(%rsi)
	movaps	960(%rbp), %xmm12
	movaps	976(%rbp), %xmm13
	movaps	992(%rbp), %xmm14
	movaps	1008(%rbp), %xmm15
	prefetcht0	1984(%rbp)
	addps	896(%rsi), %xmm8
	addps	912(%rsi), %xmm9
	addps	928(%rsi), %xmm10
	addps	944(%rsi), %xmm11
	prefetcht0	1984(%rsi)
	addps	960(%rsi), %xmm12
	addps	976(%rsi), %xmm13
	addps	992(%rsi), %xmm14
	addps	1008(%rsi), %xmm15
	movntps	%xmm8, 896(%rdi)
	movntps	%xmm9, 912(%rdi)
	movntps	%xmm10, 928(%rdi)
	movntps	%xmm11, 944(%rdi)
	movntps	%xmm12, 960(%rdi)
	movntps	%xmm13, 976(%rdi)
	movntps	%xmm14, 992(%rdi)
	movntps	%xmm15, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.mainad_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.mainad_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret

.globl ssetr_nt_t0
ssetr_nt_t0:
/* set up the stack frame */
	pushq	%rbx
	pushq	%rbp
	pushq	%r12
	pushq	%r13
	pushq	%r14
	pushq	%r15
	subq	$32, %rsp
/* process the parameters */
	movq	%rdi, %rbx
	movq	%rsi, %r15
	shlq	$10, %rbx
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r12
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r13
/* allocate */
	movq	%rbx, %rdi
	call	malloc
	movq	%rax, %r14
/* prefill */
	movq	%rbx, %rcx
	shrq	$4, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	finit
	fldpi
.pretr_nt_t0:
	fst	0(%rsi)
	fst	4(%rsi)
	fst	8(%rsi)
	fst	12(%rsi)
	fst	0(%rbp)
	fst	4(%rbp)
	fst	8(%rbp)
	fst	12(%rbp)
	addq	$16, %rsi
	addq	$16, %rbp
	loopq	.pretr_nt_t0
	ffree	%st(0)
/* wall time (start) */
	leaq	0(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* create the multiplier */
	fldln2
	fst	16(%rsp)
	fst	20(%rsp)
	movlps	16(%rsp), %xmm8
	movlhps	%xmm8, %xmm8
	ffree	%st(0)
/* execute */
	shrq	$10, %rbx
	movq	%rbx, %rcx
	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	$1024, %rax
.maintr_nt_t0:
	prefetcht0	1024(%rbp)
	movaps	0(%rbp), %xmm0
	movaps	16(%rbp), %xmm1
	movaps	32(%rbp), %xmm2
	movaps	48(%rbp), %xmm3
	prefetcht0	1024(%rsi)
	movaps	64(%rbp), %xmm4
	movaps	80(%rbp), %xmm5
	movaps	96(%rbp), %xmm6
	movaps	112(%rbp), %xmm7
	prefetcht0	1088(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1088(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	0(%rsi), %xmm0
	addps	16(%rsi), %xmm1
	addps	32(%rsi), %xmm2
	addps	48(%rsi), %xmm3
	addps	64(%rsi), %xmm4
	addps	80(%rsi), %xmm5
	addps	96(%rsi), %xmm6
	addps	112(%rsi), %xmm7
	movntps	%xmm0, 0(%rdi)
	movntps	%xmm1, 16(%rdi)
	movntps	%xmm2, 32(%rdi)
	movntps	%xmm3, 48(%rdi)
	movntps	%xmm4, 64(%rdi)
	movntps	%xmm5, 80(%rdi)
	movntps	%xmm6, 96(%rdi)
	movntps	%xmm7, 112(%rdi)
	prefetcht0	1152(%rbp)
	movaps	128(%rbp), %xmm0
	movaps	144(%rbp), %xmm1
	movaps	160(%rbp), %xmm2
	movaps	176(%rbp), %xmm3
	prefetcht0	1152(%rsi)
	movaps	192(%rbp), %xmm4
	movaps	208(%rbp), %xmm5
	movaps	224(%rbp), %xmm6
	movaps	240(%rbp), %xmm7
	prefetcht0	1216(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1216(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	128(%rsi), %xmm0
	addps	144(%rsi), %xmm1
	addps	160(%rsi), %xmm2
	addps	176(%rsi), %xmm3
	addps	192(%rsi), %xmm4
	addps	208(%rsi), %xmm5
	addps	224(%rsi), %xmm6
	addps	240(%rsi), %xmm7
	movntps	%xmm0, 128(%rdi)
	movntps	%xmm1, 144(%rdi)
	movntps	%xmm2, 160(%rdi)
	movntps	%xmm3, 176(%rdi)
	movntps	%xmm4, 192(%rdi)
	movntps	%xmm5, 208(%rdi)
	movntps	%xmm6, 224(%rdi)
	movntps	%xmm7, 240(%rdi)
	prefetcht0	1280(%rbp)
	movaps	256(%rbp), %xmm0
	movaps	272(%rbp), %xmm1
	movaps	288(%rbp), %xmm2
	movaps	304(%rbp), %xmm3
	prefetcht0	1280(%rsi)
	movaps	320(%rbp), %xmm4
	movaps	336(%rbp), %xmm5
	movaps	352(%rbp), %xmm6
	movaps	368(%rbp), %xmm7
	prefetcht0	1344(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1344(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	256(%rsi), %xmm0
	addps	272(%rsi), %xmm1
	addps	288(%rsi), %xmm2
	addps	304(%rsi), %xmm3
	addps	320(%rsi), %xmm4
	addps	336(%rsi), %xmm5
	addps	352(%rsi), %xmm6
	addps	368(%rsi), %xmm7
	movntps	%xmm0, 256(%rdi)
	movntps	%xmm1, 272(%rdi)
	movntps	%xmm2, 288(%rdi)
	movntps	%xmm3, 304(%rdi)
	movntps	%xmm4, 320(%rdi)
	movntps	%xmm5, 336(%rdi)
	movntps	%xmm6, 352(%rdi)
	movntps	%xmm7, 368(%rdi)
	prefetcht0	1408(%rbp)
	movaps	384(%rbp), %xmm0
	movaps	400(%rbp), %xmm1
	movaps	416(%rbp), %xmm2
	movaps	432(%rbp), %xmm3
	prefetcht0	1408(%rsi)
	movaps	448(%rbp), %xmm4
	movaps	464(%rbp), %xmm5
	movaps	480(%rbp), %xmm6
	movaps	496(%rbp), %xmm7
	prefetcht0	1472(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1472(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	384(%rsi), %xmm0
	addps	400(%rsi), %xmm1
	addps	416(%rsi), %xmm2
	addps	432(%rsi), %xmm3
	addps	448(%rsi), %xmm4
	addps	464(%rsi), %xmm5
	addps	480(%rsi), %xmm6
	addps	496(%rsi), %xmm7
	movntps	%xmm0, 384(%rdi)
	movntps	%xmm1, 400(%rdi)
	movntps	%xmm2, 416(%rdi)
	movntps	%xmm3, 432(%rdi)
	movntps	%xmm4, 448(%rdi)
	movntps	%xmm5, 464(%rdi)
	movntps	%xmm6, 480(%rdi)
	movntps	%xmm7, 496(%rdi)
	prefetcht0	1536(%rbp)
	movaps	512(%rbp), %xmm0
	movaps	528(%rbp), %xmm1
	movaps	544(%rbp), %xmm2
	movaps	560(%rbp), %xmm3
	prefetcht0	1536(%rsi)
	movaps	576(%rbp), %xmm4
	movaps	592(%rbp), %xmm5
	movaps	608(%rbp), %xmm6
	movaps	624(%rbp), %xmm7
	prefetcht0	1600(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1600(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	512(%rsi), %xmm0
	addps	528(%rsi), %xmm1
	addps	544(%rsi), %xmm2
	addps	560(%rsi), %xmm3
	addps	576(%rsi), %xmm4
	addps	592(%rsi), %xmm5
	addps	608(%rsi), %xmm6
	addps	624(%rsi), %xmm7
	movntps	%xmm0, 512(%rdi)
	movntps	%xmm1, 528(%rdi)
	movntps	%xmm2, 544(%rdi)
	movntps	%xmm3, 560(%rdi)
	movntps	%xmm4, 576(%rdi)
	movntps	%xmm5, 592(%rdi)
	movntps	%xmm6, 608(%rdi)
	movntps	%xmm7, 624(%rdi)
	prefetcht0	1664(%rbp)
	movaps	640(%rbp), %xmm0
	movaps	656(%rbp), %xmm1
	movaps	672(%rbp), %xmm2
	movaps	688(%rbp), %xmm3
	prefetcht0	1664(%rsi)
	movaps	704(%rbp), %xmm4
	movaps	720(%rbp), %xmm5
	movaps	736(%rbp), %xmm6
	movaps	752(%rbp), %xmm7
	prefetcht0	1728(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1728(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	640(%rsi), %xmm0
	addps	656(%rsi), %xmm1
	addps	672(%rsi), %xmm2
	addps	688(%rsi), %xmm3
	addps	704(%rsi), %xmm4
	addps	720(%rsi), %xmm5
	addps	736(%rsi), %xmm6
	addps	752(%rsi), %xmm7
	movntps	%xmm0, 640(%rdi)
	movntps	%xmm1, 656(%rdi)
	movntps	%xmm2, 672(%rdi)
	movntps	%xmm3, 688(%rdi)
	movntps	%xmm4, 704(%rdi)
	movntps	%xmm5, 720(%rdi)
	movntps	%xmm6, 736(%rdi)
	movntps	%xmm7, 752(%rdi)
	prefetcht0	1792(%rbp)
	movaps	768(%rbp), %xmm0
	movaps	784(%rbp), %xmm1
	movaps	800(%rbp), %xmm2
	movaps	816(%rbp), %xmm3
	prefetcht0	1792(%rsi)
	movaps	832(%rbp), %xmm4
	movaps	848(%rbp), %xmm5
	movaps	864(%rbp), %xmm6
	movaps	880(%rbp), %xmm7
	prefetcht0	1856(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1856(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	768(%rsi), %xmm0
	addps	784(%rsi), %xmm1
	addps	800(%rsi), %xmm2
	addps	816(%rsi), %xmm3
	addps	832(%rsi), %xmm4
	addps	848(%rsi), %xmm5
	addps	864(%rsi), %xmm6
	addps	880(%rsi), %xmm7
	movntps	%xmm0, 768(%rdi)
	movntps	%xmm1, 784(%rdi)
	movntps	%xmm2, 800(%rdi)
	movntps	%xmm3, 816(%rdi)
	movntps	%xmm4, 832(%rdi)
	movntps	%xmm5, 848(%rdi)
	movntps	%xmm6, 864(%rdi)
	movntps	%xmm7, 880(%rdi)
	prefetcht0	1920(%rbp)
	movaps	896(%rbp), %xmm0
	movaps	912(%rbp), %xmm1
	movaps	928(%rbp), %xmm2
	movaps	944(%rbp), %xmm3
	prefetcht0	1920(%rsi)
	movaps	960(%rbp), %xmm4
	movaps	976(%rbp), %xmm5
	movaps	992(%rbp), %xmm6
	movaps	1008(%rbp), %xmm7
	prefetcht0	1984(%rbp)
	mulps	%xmm8, %xmm0
	mulps	%xmm8, %xmm1
	mulps	%xmm8, %xmm2
	mulps	%xmm8, %xmm3
	prefetcht0	1984(%rsi)
	mulps	%xmm8, %xmm4
	mulps	%xmm8, %xmm5
	mulps	%xmm8, %xmm6
	mulps	%xmm8, %xmm7
	addps	896(%rsi), %xmm0
	addps	912(%rsi), %xmm1
	addps	928(%rsi), %xmm2
	addps	944(%rsi), %xmm3
	addps	960(%rsi), %xmm4
	addps	976(%rsi), %xmm5
	addps	992(%rsi), %xmm6
	addps	1008(%rsi), %xmm7
	movntps	%xmm0, 896(%rdi)
	movntps	%xmm1, 912(%rdi)
	movntps	%xmm2, 928(%rdi)
	movntps	%xmm3, 944(%rdi)
	movntps	%xmm4, 960(%rdi)
	movntps	%xmm5, 976(%rdi)
	movntps	%xmm6, 992(%rdi)
	movntps	%xmm7, 1008(%rdi)
	addq	%rax, %rsi
	addq	%rax, %rbp
	addq	%rax, %rdi
	decq	%rcx
	jnz	.maintr_nt_t0

	movq	%r12, %rsi
	movq	%r13, %rbp
	movq	%r14, %rdi
	movq	%rbx, %rcx
	decq	%r15
	jnz	.maintr_nt_t0

/* wall time (finish) */
	leaq	16(%rsp), %rdi
	xorq	%rsi, %rsi
	call	gettimeofday
/* free */
	movq	%r14, %rdi
	call	free
/* free */
	movq	%r13, %rdi
	call	free
/* free */
	movq	%r12, %rdi
	call	free
/* calculate */
	movq	16(%rsp), %rax
	subq	0(%rsp), %rax
	movq	$1000000, %rdx
	mulq	%rdx
	addq	24(%rsp), %rax
	subq	8(%rsp), %rax
/* restore and return */
	addq	$32, %rsp
	popq	%r15
	popq	%r14
	popq	%r13
	popq	%r12
	popq	%rbp
	popq	%rbx
	ret
